# \file ./IncludeDirectories.cmake
# \date 05/13/2003
# \author Anilkumar Patro

#-----------------------------------------------------------------------------
# Include directories for other projects installed on the system.
SET(XMDV_INCLUDE_DIRS_SYSTEM "")

# OpenGL include directories.
SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM}
    ${OPENGL_INCLUDE_DIR})

# X include directories.
SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM}
    ${X11_INCLUDE_DIR})

# Tcl/Tk include directories.
SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${TCL_INCLUDE_PATH})
SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${TK_INCLUDE_PATH})
IF (WIN32)
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${TK_XLIB_PATH})
ENDIF (WIN32)

# Oracle Pro*C/C++ include directories
IF(XMDV_USE_BACKEND)
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${ORACLE_PROC_INCLUDE_PATH})    
ENDIF(XMDV_USE_BACKEND)

# XML Parser include directories
IF(XMDV_USE_META)
	SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/arabica)

	IF(UNIX)
		SET(XERCES_INCLUDE_DIR ${XMDV_SOURCE_DIR}/ext/libs/xerces-linux/include)
	ELSE(UNIX)
		SET(XERCES_INCLUDE_DIR ${XMDV_SOURCE_DIR}/ext/libs/xerces-win32/include)
	ENDIF(UNIX)

    IF(XMDV_USE_XMLPARSER_XERCES)
	    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XERCES_INCLUDE_DIR})
    ENDIF(XMDV_USE_XMLPARSER_XERCES)
    IF(XMDV_USE_XMLPARSER_EXPAT)
            SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${EXPAT_INCLUDE_DIR})
    ENDIF(XMDV_USE_XMLPARSER_EXPAT)
    IF(XMDV_USE_XMLPARSER_MSXML)
            SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${MSXML_INCLUDE_DIR})
    ENDIF(XMDV_USE_XMLPARSER_MSXML)
    IF(XMDV_USE_XMLPARSER_LIBXML)
            SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${LIBXML_INCLUDE_DIR})
    ENDIF(XMDV_USE_XMLPARSER_LIBXML)
ENDIF(XMDV_USE_META)

#-----------------------------------------------------------------------------
# Include directories for 3rd-party utilities provided by XMDV.
#OTL Directory
IF(XMDV_USE_BACKEND)
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/otl/include)    
    IF(UNIX)
         SET(ODBC_INCLUDE_DIR /home/qgcui/easysoft/unixODBC/include)
         SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${ODBC_INCLUDE_DIR})
    ENDIF(UNIX)
ENDIF(XMDV_USE_BACKEND)


IF(XMDV_USE_BACKEND)
    #Spatial Index directory
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/spatialindex/lib)    
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/spatialindex/tools/lib)    
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/spatialindex/tools/tools)    

     #ZThread directory
     SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/zthread-2.3.1/include)    
     SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/otl/include)
     SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/spatialindex/lib)
     SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM}  ${XMDV_SOURCE_DIR}/ext/libs/spatialindex/tools/lib)
     
    #For the prefetcher
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/include/cache/prefetcher)
    #For the logger that the backend uses
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/xmdvdbg)
ENDIF(XMDV_USE_BACKEND)

# TOGL directory
SET(TOGL_DIR ${XMDV_SOURCE_DIR}/ext/libs/togl)
IF(UNIX)
    SET(TOGL_DIR ${TOGL_DIR}-linux)
ENDIF(UNIX)
SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${TOGL_DIR})

# debug utilities directory
SET(DEBUG_DIR ${XMDV_SOURCE_DIR}/ext/libs/xmdvdbg)
SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${DEBUG_DIR})

# ARABICA directory
IF(XMDV_USE_META)
    SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${XMDV_SOURCE_DIR}/ext/libs/arabica)
ENDIF(XMDV_USE_META)

# freetype directory
SET(FREETYPE_DIR ${XMDV_SOURCE_DIR}/ext/libs/freetype)
SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${FREETYPE_DIR}/include)

# glgooey directory
SET(GLGOOEY_DIR ${XMDV_SOURCE_DIR}/ext/libs/GLGooey)
SET(XMDV_INCLUDE_DIRS_SYSTEM ${XMDV_INCLUDE_DIRS_SYSTEM} ${GLGOOEY_DIR}/libs)

#-----------------------------------------------------------------------------

# Include directories from the source tree.
SET(XMDV_INCLUDE_DIRS_SOURCE_TREE "")
SET(XMDV_INCLUDE_DIRS_SOURCE_TREE ${XMDV_INCLUDE_DIRS_SOURCE_TREE} ${XMDV_INCLUDE_DIR})

#For the cache
SET(XMDV_INCLUDE_DIRS_SOURCE_TREE ${XMDV_INCLUDE_DIRS_SOURCE_TREE} ${XMDV_INCLUDE_DIR}/cache)




#SET(XMDV_INCLUDE_DIRS_SOURCE_TREE ${XMDV_INCLUDE_DIRS_SOURCE_TREE} ${XMDV_INCLUDE_DIR}/xmdv)

#IF(XMDV_USE_META)
#   SET(XMDV_INCLUDE_DIRS_SOURCE_TREE ${XMDV_INCLUDE_DIRS_SOURCE_TREE} ${XMDV_INCLUDE_DIR}/meta)
#ENDIF(XMDV_USE_META)

# Log:
# $Log: IncludeDirectories.cmake,v $
# Revision 1.6  2005/11/11 15:39:23  qgcui
# Adjust for window.
#
# Revision 1.5  2005/10/13 23:37:21  qgcui
# Porting to linux
#
# Revision 1.4  2005/06/24 04:44:58  anil
# *** empty log message ***
#
# Revision 1.3  2004/05/10 22:15:41  nishantm
# Changed the path of the logger library
#
# Revision 1.2  2004/04/16 20:36:09  nishantm
# 1) Added the Cmake entries for the new cache on 04/16/2004
#
# Revision 1.1  2003/09/01 23:09:21  anil
# Initial import of project tree.
#
#
