//	---------------------------------------------------------------------------
//	$Header: /home/xmdv/CODE/CVSREPOSITORY/xmdvtool/ext/libs/xmdvdbg/log/nilstream.h,v 1.1 2004/04/13 22:03:57 anil Exp $
//
//	(c) Copyright 2002 Anthony Bowyer-Lowe.  All rights reserved.
//
//	Anthony Bowyer-Lowe / ynohtna
//	ynohtna@ynohtna.org
//	http://www.ynohtna.org/
//	---------------------------------------------------------------------------
#if !defined(ANTHONY_NILSTREAM_HEADER)
#define ANTHONY_NILSTREAM_HEADER

#include <ios>


//	---------------------------------------------------------------------------
//	A stream class that compiles away to nothing under an optimised build
//	(assuming insertion code has no side-effects).
//
//	Pollution of global and std namespace is necessary for correct
//	operation and optimisation of this class.
//
//	Polluting the std namespace is never encouraged, but is allowed when
//	the polluting functions only interfer with the handling of custom (non-stl)
//	classes.
//
//	Will only compile if the replaced is used minimally: simple insertions,
//	and the commonly used manipulators (ends, endl, flush).
//	---------------------------------------------------------------------------
namespace debug
{
namespace log
{

class nilstream
{
public:
	nilstream()	{	}
	nilstream& operator<<(nilstream& (__cdecl *Functor)(nilstream&)) {
		return *this;
	}
	nilstream& operator<<(std::ios& (__cdecl *_Iomanip)(std::ios&)) {
		return *this;
	}
};

} // End namespace log
} // End namespace debug

//	---------------------------------------------------------------------------
template<typename _O>
inline anthony::nilstream& operator<<(anthony::nilstream& stream, _O&) {
	return stream;
}

//	---------------------------------------------------------------------------
namespace std {	//	Not particulary comprehensive.
	anthony::nilstream& ends(anthony::nilstream& _O)	{ return _O; }
	anthony::nilstream& endl(anthony::nilstream& _O)	{ return _O; }
	anthony::nilstream& flush(anthony::nilstream& _O)	{ return _O; }
}


//	---------------------------------------------------------------------------
#endif	//	ANTHONY_NILSTREAM_HEADER
