#ifndef _CACHE_ITERATOR_H
#define _CACHE_ITERATOR_H

#include <Iterator.h>
#include <ICacheEntry.h>

namespace cache{

	//Forward References
	class Iload;
	class ServedItemVisitor;

	class CacheIterator : public ::Iterator<ICacheEntry*>
	{
	public:
		CacheIterator(Iload *iload,		
					  std::queue<ICacheEntry*>* cacheQueue,
					  ServedItemVisitor* servedItemVisitor);

		/*
		* Get the next cache entry.
		*/
		ICacheEntry* get_next();

		bool isDone();

		virtual ~CacheIterator();

	private: 
		std::queue<ICacheEntry*>* cacheQueue;
		ServedItemVisitor* servedItemVisitor;
		Iload *iload;
		unsigned long count;
	};
}
#endif
