#ifndef _CACHE_SEARCHER_H
#define _CACHE_SEARCHER_H

#include <SpatialIndex.h>
#include <list>

namespace cache
{
	//Forward References
	class ICacheEntry;
	class Brush;

	class CacheSearcher : public SpatialIndex::IVisitor
	{
	public:	
		CacheSearcher(std::list<ICacheEntry*>* resultList);

		//Sets the parameters for the searh in the cache searcher.		
		void setSearchParameters(Brush *in);

		//Visitor functions
		ICacheEntry* convertToPointer(unsigned char* data);


		void visitNode(const SpatialIndex::INode &in);

		//Helper functions
		void visitData(const SpatialIndex::IData &in);

	private:
		Brush* currentBrush;	

		std::list<ICacheEntry*>* resultList;
	};
}
#endif //_CACHE_SEARCHER_H
