#ifndef _DOUBLY_LIST_H
#define _DOUBLY_LIST_H
#include <stdio.h>
#include <iostream>

namespace cache
{

	template <class T>
	class DoublyList
	{
	public:
		struct Node {
			Node *pNext;
			Node *pPrev;
			T nData;

			Node(){}

			Node(T nData)
			{
				this->nData = nData;
				this->pNext = NULL;
				this->pPrev = NULL;
			}
		};

		DoublyList()
		{
			pHead = NULL;
			pTail = NULL;
		}


		// Appends a node to the end of the list

		void AppendNode(Node *pNode)
		{		
			if (pHead == NULL) {
				pHead = pNode;
				pNode->pPrev = NULL;
			}
			else {
				pTail->pNext = pNode;
				pNode->pPrev = pTail;
			}
			pTail = pNode;
			pNode->pNext = NULL;
		}


		void InsertNode(Node *pNode, Node *pAfter)
		{
			pNode->pNext = pAfter->pNext;
			pNode->pPrev = pAfter;
			if (pAfter->pNext != NULL)
				pAfter->pNext->pPrev = pNode;
			else
				pTail = pNode;
			pAfter->pNext = pNode;
		}

		Node* getFirst()
		{
			return(pHead);
		}

		bool isEmpty()
		{
			if(pTail == NULL && pHead == NULL)
				return(true);
			else 
				return(false);
		}

		void RemoveNode(Node *pNode)
		{
			if (pNode->pPrev == NULL)
				pHead = pNode->pNext;
			else
				pNode->pPrev->pNext = pNode->pNext;
			if (pNode->pNext == NULL)
				pTail = pNode->pPrev;
			else
				pNode->pNext->pPrev = pNode->pPrev;
		}

		/**
		* Returns the number of nodes in the list
		* \return unsigned int
		*/
		unsigned int count()
		{
			unsigned int count =0;
			Node* pNode = pHead;
			while (pNode != NULL)
			{
				pNode = pNode->pNext;
				count++;
			} // while (pHead != NULL)		
			return(count);
		}


		~DoublyList()
		{  
			Node* pNode = NULL;
			while (pHead != NULL)
			{
				pNode = pHead;
				RemoveNode(pHead);			
				delete(pNode);
			} // while (pHead != NULL)		
		}	


	private:
		Node* pHead;

		Node* pTail;
	};
}
#endif //_REPLACEMENT_POLICY_H