#ifndef _ICACHE_CONTROLLER_H
#define _ICACHE_CONTROLLER_H
#include <Iterator.h>
namespace cache
{
	//Forward References
	class ILoadListener;
	class PerformanceStatistics;

	class ICacheController
	{
	public:
		virtual void addLoadListener(ILoadListener* loadListener)=0;

		virtual Iterator<ICacheEntry*>* load(double e1,double e2,double lod,int type)=0;

		/*
		* This returns the time taken to search in the cache
		* in msec
		*	@return unsigned long
		*/
		virtual PerformanceStatistics* getPerformanceStatistics()=0;

		virtual ~ICacheController(){}
		
	};
}
#endif
