#ifndef _LOAD_REQUESTER_H
#define _LOAD_REQUESTER_H

#include <cache/IFragThresholdVisitor.h>

namespace cache
{

	/*
	*	The main objective of this class is to reduce the coupling
	* between the PrefetchController and the Prefetcher
	* Don't have any good reason to make this class
	*/

	//Forward References
	class CacheManager;
	class PrefetchController;
	class CacheIterator;
	class AbstractRegionFactory;
	class Brush;
	class PerformanceStatistics;
	class QueryModifier;

	class LoadRequester : public IFragThresholdVisitor
	{
	private:
		LoadRequester(CacheManager* cacheManager,
					  PrefetchController* prefetchController);



	public:
		static LoadRequester* getInstance();

		static void make(CacheManager* cacheManager,
						 PrefetchController* prefetchController);

		CacheIterator* load(Brush* brush,
			AbstractRegionFactory *regionFactory,
			PerformanceStatistics &performanceStatistics,
			QueryModifier& queryModifier);

		/*
		 *	Implementing the interface IFragThresholdVistor
		 */
		bool exceededFragThreshold();

	private:
		//Stores the pointer to the cache manager
		CacheManager *cacheManager;
		//Stores the pointer to the prefetch controller.
		PrefetchController *prefetchController;
		//Stores the pointer to the load requester
		static LoadRequester* loadRequester;	
	};
}
#endif //_LOAD_REQUESTER_H
