#ifndef _SUPER_INDEX
#define _SUPER_INDEX

#include <cache/Cache.h>

namespace cache
{
	//Forward References	
	class PerformanceStatistics;

class SuperIndex : public IIndex
{
	public:
	/*
	 *	Construnts a new super index
	 */
	SuperIndex(unsigned long SizeOfCache,
			   unsigned int switchThreshold,	
			   PerformanceStatistics* perStatistics,
			   SequentialIndex* seqIndex,
			   RTreeIndex* rtreeIndex);

	
	/**
	* Copy constructor undefined
	* \param sequentialIndex 
	* \return 
	*/
	SuperIndex(const SequentialIndex& sequentialIndex);

	/**
	* Operator = undefined
	* \param squentialIndex 
	* \return 
	*/
	SuperIndex& operator =(SequentialIndex& squentialIndex);

	/**
	* Deletes the data items
	* \param *iShape 
	* \param id 
	*/
	void deleteData(Tools::Geometry::IShape *iShape,unsigned long id);

	/**
	* Inserts the cache entry into the index.
	* Called when a new 
	* \param &cacheEntry 
	* \return 
	*/
	void insertData(ICacheEntry& cacheEntry);

	~SuperIndex();
	/**
	* Does a sequential scan over the complete data set in the main memory
	* \param &brush 
	* \return 
	*/
	std::list<ICacheEntry*>& search(Brush &brush);

	
	private:
		//Stores the reference to the performance statistics
		PerformanceStatistics* perStatistics;
		//Stores the reference to the seq index
		SequentialIndex* seqIndex;
		//Stores the reference to the rtree index
		RTreeIndex *rTreeIndex;
		//Stores the size of the cache
		unsigned long sizeOfCache;
		//Stores the value of the switch threshold
		unsigned int switchThreshold;
};

}
#endif
