/* file: expAverage.h
 * purpose: Definitions for Exponential Weighted Average class
 * revision log:
 */

typedef struct expAverage_Str *expAverage;
 /* Defines 'expAverage' as a pointer to a structure that
  * is not defined here and so is not accessible to the outside world
  */

expAverage expAverage_Create() ;
 /*	Returns a new expAverage, or NULL if there isn't enough memory.
  */

void expAverage_Destroy(expAverage g) ;
 /* Frees the memory associated with 'expAverage'. 
  */

float expAverage_Update(expAverage g, float m) ;
 /* Updates the expAverage value with the new meaure 
  */

float expAverage_GetValue(expAverage g) ;
 /*	Returns the latest value of the expAverage in float form
  */

void expAverage_Test() ;
 /* Tests the entire expAverage class 
  */