#ifndef CHierGlyph_H
#define CHierGlyph_H

#include <xmdv/CHierDisplay.h>
#include <xmdv/Vec2.h>

class CHierGlyph: public CHierDisplay 
{
private: 
    double blocksize;
    int blockcnt;  
    double halfblocksize;
    int count;

    double basex;
    double basey;
    double *isin;
    double *icos;
    double alpha;
    ARR<Vec2> polymean;
    ARR<Vec2> polymax;
    ARR<Vec2> polymin;
    int brushedClusterNumber;
    int unbrushedClusterNumber;

    ARR<Vec2> band;

public:
	CHierGlyph(CHierDisplayInformation* hier_info);
	~CHierGlyph();

private:
	//draw a single cluster;
	void DrawSingleCluster(const Cluster &c, bool brushed);
	//set parameters used for drawing;
	void SetParameters();
	//free space used for drawing;
	void FreeSpace();

    void DrawSingleNodeBand(const Cluster &c, double density, bool brushed);

    void CountBrushedClusters( const Cluster &node );

    void CountUnbrushedClusters( const Cluster &node );

    void InputMouseMotion(int x, int y);
};

#endif
