//modified by Jing Yang after 7/6/2001
#include <xmdv/ogl.h>
#include <xmdv/InterRing/CInterRingDataDisplay.h>
#include <xmdv/XmdvTool.h>
#include <xmdv/colormap.h>
#include <xmdv/magnify.h>
#include <xmdv/brush_oper.h>

CInterRingDataDisplay::CInterRingDataDisplay() : CInterRingDisplay()
{
}


CInterRingDataDisplay::~CInterRingDataDisplay()
{
    if ( tree != NULL )
    {
        delete tree;
        tree = NULL;
    }
}


CInterRingClusterTree* CInterRingDataDisplay::GetTree()
{
    if ( tree )
        return tree;

    CInterRingDataClusterTree *data_tree = new CInterRingDataClusterTree();
    if ( data_tree->ConstructTree() )
        return data_tree;
    else 
    {
        delete data_tree;
        return NULL;
    }
}



void CInterRingDataDisplay::InputButtonPress_Selection(int button, int x, int y)
{
    if (!tree) return;

    if ( button == 0 )
    {
        current_node = FindNode(x, y);
        if ( current_node == NULL )
            return;
        if ( current_node->selected == false )
        {
            current_node->selected = true;
//            dim_reducer->AddRepresentativeDim((CInterRingDimCluster *)current_node);
    		if ( current_node->name != NULL )
            {
                char stri[100];   
	    	    strcpy(stri, current_node->name);
	    	    strcat(stri, " has been selected!");
                appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),stri, canvas->name);
            }
        }
        else
        {
            current_node->selected = false;
//            dim_reducer->DeleteRepresentativeDim((CInterRingDimCluster *)current_node);
    		if ( current_node->name != NULL )
            {
    		    char stri[100];   
	    	    strcpy(stri, current_node->name);
	    	    strcat(stri, " has been unselected.");
                appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),stri, canvas->name);
            }
        }
        canvas->Refresh();
    }
	else if ( button == 2 )
	{
        current_node = FindNode(x, y);
        if ( current_node == NULL )
            return;

//        dim_reducer->current_node = (CInterRingDimCluster *)current_node;

		double radius = current_node->GetRadius();
        y = Togl_Height(canvas->GetWidget()) - y - 1;
		
		char str[100];
		sprintf(str, " %d %d %lf", x, y, radius);

        Tcl_VarEval(Togl_Interp(canvas->GetWidget()), ".interRingSB::PopInterRingSBDialog ", str, 0);
	} 
}


