//modified by Jing Yang after 7/6/2001
#include <xmdv/ogl.h>
#include <xmdv/InterRing/CInterRingDimDisplay.h>
#include <xmdv/XmdvTool.h>
#include <xmdv/colormap.h>
#include <xmdv/magnify.h>
#include <xmdv/brush_oper.h>
#include <xmdv/CDimReducer.h>

CInterRingDimDisplay::CInterRingDimDisplay() : CInterRingDisplay()
{
//    tree = GetTree();
}


CInterRingDimDisplay::~CInterRingDimDisplay()
{
}


CInterRingClusterTree* CInterRingDimDisplay::GetTree()
{
    if ( g_globals.dtree )
        return g_globals.dtree;

    if ( ! g_globals.dim_reducer )
    g_globals.dim_reducer = new CDimReducer();

    g_globals.dtree = g_globals.dim_reducer->GetDimClusterTree();
    return g_globals.dtree;
}


void CInterRingDimDisplay::InputButtonPress_Selection(int button, int x, int y)
{
    if (!tree) return;

    if ( button == 0 )
    {
        current_node = FindNode(x, y);
        if ( current_node == NULL )
            return;
        if ( current_node->selected == false )
        {
            current_node->selected = true;
            g_globals.dim_reducer->AddRepresentativeDim((CInterRingDimCluster *)current_node);
    		char stri[100];   
	    	strcpy(stri, current_node->name);
	    	strcat(stri, " has been selected!");
            appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),stri, canvas->name);
        }
        else
        {
            current_node->selected = false;
            g_globals.dim_reducer->DeleteRepresentativeDim((CInterRingDimCluster *)current_node);
    		char stri[100];   
	    	strcpy(stri, current_node->name);
	    	strcat(stri, " has been unselected.");
            appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),stri, canvas->name);
        }
        canvas->Refresh();
    }
	else if ( button == 2 )
	{
        current_node = FindNode(x, y);
        if ( current_node == NULL )
            return;

        g_globals.dim_reducer->current_node = (CInterRingDimCluster *)current_node;

		double radius = current_node->GetRadius();
        y = Togl_Height(canvas->GetWidget()) - y - 1;
		
		char str[100];
		sprintf(str, " %d %d %lf", x, y, radius);

        Tcl_VarEval(Togl_Interp(canvas->GetWidget()), ".interRingSB::PopInterRingSBDialog ", str, 0);
	} 
}

/*void CInterRingDimDisplay::DrawSingleClusterName(CInterRingCluster *node)
{
    if ( ! node->selected )
        return;
    canvas->SetForeground(interface_color[TEXT]);
    double mid_ang = node->GetMidAngle();
    double radi = (radius[node->level-1] + radius[node->level])/2.0;
	Vec2 p1 = MapData(radi, mid_ang);

    char buf[50];
    sprintf(buf, "%s", node->name);
    canvas->DrawConfinedString(p1.X, p1.Y, buf, 1);

} */


