//modified by Jing Yang after 7/6/2001

// SYSTEM INCLUDES
//
#include <cmath>
#include <iostream> 
#include <stdlib.h>
#include <sys/stat.h>
#include <string.h>
#include <stdio.h>
#include <sstream>

#include "X11/keysym.h"

// PROJECT INCLUDES
//
#include <xmdv/stats.h>

#include <xmdv/XmdvTool.h>
#include <xmdv/macros.h>
#include <xmdv/ogl.h>
#include <xmdv/okcdata.h>
#include <xmdv/cluster.h>
//jing
#include <xmdv/brush.h>
#include <xmdv/brush_oper.h>
#include <xmdv/magnify.h>
#include <xmdv/multi_select.h>

#include <xmdv/CFlatDisplayInformation.h>
#include <xmdv/CHierDisplayInformation.h>
#include <xmdv/CDimReductionDisplayInformation.h>
#include <xmdv/CScreenDistortion.h>

#include <xmdv/SessionMgmt/HistMgmt.h>  //YK

#include <xmdv/CFlatParcoord.h>
#include <xmdv/CFlatScatter.h>
#include <xmdv/CFlatDimstack.h>
#include <xmdv/CFlatGlyph.h>
#include <xmdv/CFlatPixel.h>
#include <xmdv/CParcoordTool.h>
#include <xmdv/CGlyphTool.h>
#include <xmdv/CDimstackTool.h>
#include <xmdv/PixelTool.h>
#include <xmdv/CHierParcoord.h>
#include <xmdv/CHierScatter.h>
#include <xmdv/CHierGlyph.h>
#include <xmdv/CHierDimstack.h>
#include <xmdv/CHierPixel.h>
#include <xmdv/CHierNav.h>
#include <xmdv/CHierHist.h>
#include <xmdv/CHierTreemap.h>

#include <xmdv/CMixedDisplay.h>

#include <xmdv/InterRing/CInterRingDimDisplay.h>
#include <xmdv/InterRing/CInterRingDimClusterTree.h>

#include <xmdv/InterRing/CInterRingDataDisplay.h>
#include <xmdv/InterRing/CInterRingDataClusterTree.h>

#include <xmdv/OnlineDataClustering.h>
#include <xmdv/ColorMapEditor.h>

/* SID */
#include <backend/db_buffer.h>
#include <backend/db_clock.h>
#include <backend/db_prefetch.h>
#include <backend/db_connect.h>
#include <backend/db_GLOBAL.h>

#ifdef XMDV_USE_BACKEND
#include <cache/CacheBuilder.h>
#include <cache/ConfigFileParser.h>
#include <cache/DBFileParser.h>
#include <cache/ICacheController.h>
#include <cache/ConfigurationStore.h>
#include <cache/FileNotFoundException.h>
#endif

//#include <glgooey/WindowManager.h>
//#include <glgooey/PropertyScheme.h>

//Anil
#include "XmdvConfig.h"

//debbie
#include <xmdv/OrderDimension.h>

//debbie


#ifdef USE_META
#include <fstream>
#include <meta/Meta.h>
#endif // USE_META
//Anil

#ifdef _WIN32
#include <direct.h>
#define strcasecmp stricmp
#else
#include <unistd.h> // for Linux sleep function
#endif

#if defined(_MSC_VER) && defined(_WIN32)
#if _UNICODE
	#pragma comment(linker,"/ENTRY:wmainCRTStartup")
#else
	#pragma comment(linker,"/ENTRY:mainCRTStartup")
#endif
#ifdef _DEBUG
	#pragma comment(linker,"/SUBSYSTEM:CONSOLE")
#else
	#pragma comment(linker,"/SUBSYSTEM:WINDOWS")
#endif // _DEBUG
#endif /* _MSC_VER, _WIN32 */

int DSIZE = 1;
unsigned long interface_color[NUM_INTERFACE_ITEM];
char oldType[50];
//new change
static char interface_file[200];

/* SID */
typedef struct {
	int time;
	int type;
	double value;
	Tcl_Interp* interp;
} TestData;

/* SID */
int Prefetcher = 1;
int BrushSemantic = 0;		/* ALL = 0, ANY = 1, ... */
int Prefetch_Strategy = 1;		/* Random = 1, Direction = 2, focus = 3, no = 0*/

bool backend = false;
bool stoppan = false; // to stop panning set it to true- Charudatta

const RGBt RGBt::BLACK = RGBt(0,0,0);
const RGBt RGBt::WHITE = RGBt();

// Anil - [2/9/2004]
CGlobals::CGlobals()
{

	curr_brush = NULL;
	g_globals.btree = NULL;

	flat_info = NULL;
	hier_info = NULL;
	dim_reduction_info = NULL;
	screen_distortion = NULL;
	dtree = NULL;
	dim_reducer = NULL;
	histMgmt = NULL;	//YK

	default_file_name = NULL;

	flatparcoord = NULL;
	flatscatter = NULL;
	flatglyph = NULL;
	flatdimstack = NULL;
	flatqipixel = NULL;

	hierparcoord = NULL;
	hierscatter = NULL;
	hierglyph = NULL;
	hierdimstack = NULL;
	hierpixel = NULL;

	hiernav = NULL;
	hierhist = NULL;
	parcoordtool = NULL;
	hiertreemap = NULL;
	glyphtool = NULL;
	dimstacktool = NULL;
	pixeltool = NULL;
	interring = NULL;
	cmapeditor = NULL;

	dataset = NULL;
	mainCanvas = NULL;

	reorderParameters = NULL;		// added by debbie

//	static float unbrushedCMapVals[][5] = {
//		{ 0, 0, 255, 255, 255 },
//		{ 255, 200, 255, 100, 255 },
//	};
//	pixelUnbrushedCMap = new colormap("Pixel Brushed", new ColorRamp(CMAPSIZE, 2, unbrushedCMapVals),
//		CMAPSIZE, colormap::MODEL_HSV);
	pixelUnbrushedCMap = NULL;
	pixelBrushedCMap = NULL;
	buffersize = 0;
}

//------------------------------------------------------------------------
//	Random - (safer) uniform random number generator
//
//	The code given here is taken from "Numerical Recipes in C" by
//	William Press, Brian Flannery, Saul Teukolsky, and William
//	Vetterling. The task of the code is to do an additional randomizing
//	shuffle on the system-supplied random number generator to make it
//	safer to use. 
//
//	Returns a uniform deviate between 0.0 and 1.0 using the
//	system-supplied routine "random()". Set kmIdum to any negative value
//	to initialise or reinitialise the sequence.
//------------------------------------------------------------------------

double CGlobals::GetRandomNum()
{
//	int j;

	static double y, maxran, v[98];	// The exact number 98 is unimportant
//	static int iff	= 0;

	// As a precaution against misuse, we will always initialize on the first
	// call, even if "kmIdum" is not set negative. Determine "maxran", the
	// next integer after the largest representable value of type int. We
	// assume this is a factor of 2 smaller than the corresponding value of
	// type unsigned int. 

//	if (iff == 0)
//	{
//		iff = 1;
		maxran = RAND_MAX+1.0;

//		for (j = 1; j <= 97; j++)	// exercise the system routine
//			rand();			// (value intentionally ignored)
//
//		for (j = 1; j <= 97; j++)	// Then save 97 values and a 98th
//			v[j] = rand();
//		y = rand();
//	}

	// This is where we start if not initializing. Use the previously saved
	// random number y to get an index j between 1 and 97. Then use the
	// corresponding v[j] for both the next j and as the output number. */

//	j = 1 + (int) (97.0 * (y / maxran));
//	y = v[j];
//	v[j] = rand();			// Finally, refill the table entry
	// with the next random number from
	// "random()" 
	return(rand() / maxran);
}

//-----------------------------------------------------------------------------
void CGlobals::RegisterCMap(colormap& cmap)
{
	m_cmaps.insert(std::pair<std::string, colormap*>(cmap.GetName(), &cmap));
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void CGlobals::UnregisterCMap(colormap& cmap)
{
	CMapRegistry::iterator iter = m_cmaps.find(cmap.GetName());
	if (iter != m_cmaps.end()) {
		m_cmaps.erase(iter);
	}
}
//-----------------------------------------------------------------------------

CGlobals::~CGlobals() 
{
	SAFE_DELETE(flat_info);
	SAFE_DELETE(hier_info);
	SAFE_DELETE(dim_reduction_info);
	SAFE_DELETE(screen_distortion);
	//	SAFE_DELETE(dtree);
	SAFE_DELETE(dim_reducer);
	SAFE_DELETE(histMgmt);	//YK

	SAFE_DELETE_ARR(default_file_name);

	SAFE_DELETE(flatparcoord);
	SAFE_DELETE(flatscatter);
	SAFE_DELETE(flatglyph);
	SAFE_DELETE(flatdimstack);
	SAFE_DELETE(flatqipixel);

	SAFE_DELETE(hierparcoord);
	SAFE_DELETE(hierscatter);
	SAFE_DELETE(hierglyph);
	SAFE_DELETE(hierdimstack);
	SAFE_DELETE(hierpixel);

	SAFE_DELETE(hiernav);
	SAFE_DELETE(hierhist);
	SAFE_DELETE(parcoordtool);
	SAFE_DELETE(hiertreemap);
	SAFE_DELETE(glyphtool);
	SAFE_DELETE(dimstacktool);
	SAFE_DELETE(pixeltool);
	SAFE_DELETE(interring);
	SAFE_DELETE(cmapeditor);

	SAFE_DELETE(dataset);
	SAFE_DELETE(mainCanvas);

	SAFE_DELETE(btree);

	SAFE_DELETE(reorderParameters);         // added by debbie

	CHierHist::cfHistoFinalize();
	//	SAFE_DELETE(curr_brush);
	SAFE_DELETE(pixelBrushedCMap);
	SAFE_DELETE(pixelUnbrushedCMap);
}

CGlobals g_globals;

// Anil

/* Jing SID */
//these two functions take place of appSetBackend, with username and password as parameters. Jing
/*
 *	The input arguments to this function should
 *  be the user name, passwd, dsn,
 *  name of the .db file to be used.
 * argv[1] contains the database file
 * argv[2] username
 * argv[3] passwd
 * argv[4] dsn 
 */


/**
 * Extracts the name of the db file from the okc file
 * \param okcFileName 
 * \return 
 */
static std::string extractDbFileName(const char* okcFileName)
{
	char* dbFileName = new char[strlen(okcFileName)+1];
	strcpy(dbFileName,okcFileName);
	char* ptr = strstr(dbFileName,"okc");
	ptr[0] = 'd';ptr[1] = 'b';ptr[2] = 's';
	std::string strdbFileName(dbFileName);
	delete[] dbFileName;
	return(strdbFileName);
}

void initCache(std::string dbFileName,
			   std::string userName,
			   std::string passwd,
			   std::string dsnsource)
{		

#ifdef XMDV_USE_BACKEND
	cache::DBFileParser dbFileParser(dbFileName);
	cache::DBConfigStore* dbConfigStore = dbFileParser.getConfigStore();
	dbConfigStore->userName = userName;
	dbConfigStore->passwd = passwd;	
	dbConfigStore->dsnsource = dsnsource;	

	//Now use the defalut config parameters
	//Note 3000 is the size of the cache


	cache::CacheConfigStore* cfgStore = new cache::CacheConfigStore(3000);

	//Builds the cache
	cache::CacheBuilder* builder = new  cache::CacheBuilder(cfgStore,dbConfigStore);

	//Stores the reference to the cache controller
	cache::ICacheController* cacheController = builder->getCacheController();

	///////////////////////////////////////////////////////////////////
	//Sets the values for CHierDisplayInformation

	g_globals.hier_info->databaseInfo.cacheBuilder = builder;

	g_globals.hier_info->databaseInfo.cacheConfigStore = cfgStore;

	g_globals.hier_info->databaseInfo.cacheController = cacheController;

	g_globals.hier_info->databaseInfo.dbConfigStore = dbConfigStore;

	//To record the user trace
	g_globals.hier_info->databaseInfo.histfptr =  fopen("history.ses","a");

	//Deleting the btree to test the working of the backend and see the memory occupied
	if(g_globals.btree != NULL)
	{
		hierDeleteClusterTree();
		g_globals.btree = NULL;
	}
	////////////////////////////////////////////////////////////////////	

	backend = true;
	g_globals.hier_info->SetBackend(backend);

	if (g_globals.dataset && g_globals.btree && g_globals.hier_info->database) {
		/* SID */
		std::cout<<"";
	}
#endif
}


static int appConnectDatabase(ClientData clientData, Tcl_Interp* interp,
							  int argc, char* argv[])
{
#ifdef XMDV_USE_BACKEND
	try{
	//Deriving the name of the dbs file
	//Has to be same as the okc file but a different extenstion
	std::string strDbFileName = extractDbFileName(g_globals.dataset->datafile);
	//Now use the defalut config parameters
	//Note 3000 is the size of the cache.		
	//Makes the cache and initializes the state of the database
	initCache(strDbFileName,argv[1],argv[2], argv[3]);

	appRefreshAllCanvas(interp);

		Tcl_VarEval(interp, "ShowCaption \"",
			"Connected to the database successfully. \"", 0);		
	}catch(cache::FileNotFoundException fe)
	{
		std::cerr<<fe;
		std::ostringstream stream;
		stream<<fe<<"\"";
		
		Tcl_VarEval(interp, "ShowCaption \"",
				    stream.str().c_str(), 0);

	}catch(otl_exception& p){ // intercept OTL exceptions
		std::ostringstream stream;
		stream<<"Connect Exception"<<"\"";
		std::cerr<<p.code<<std::endl; // print out error code
		std::cerr<<p.sqlstate<<std::endl; // print out error SQLSTATE
		std::cerr<<p.msg<<std::endl; // print out error message
		std::cerr<<p.stm_text<<std::endl; // print out SQL that caused the error
		std::cerr<<p.var_info<<std::endl; // print out thevariable that caused the error
		Tcl_VarEval(interp, "ShowCaption \"",
				    stream.str().c_str(), 0);
	}								
#endif
	return TCL_OK;

}



static int appDisconnectDatabase(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	#ifdef XMDV_USE_BACKEND
	if (backend == true) {
		backend = false;
		//Note the cache controller will be deleted by the cache builder.
		delete(g_globals.hier_info->databaseInfo.cacheBuilder);
		delete(g_globals.hier_info->databaseInfo.cacheConfigStore);
		delete(g_globals.hier_info->databaseInfo.dbConfigStore);		
		
		g_globals.hier_info->SetBackend(backend);
		appRefreshAllCanvas(interp);
	}
	#endif
	return TCL_OK;
}



static int appStartBackendDemo(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
//	if ( backend == true )
	 {
//	Tcl_VarEval(interp, "SetPrefetcher ", "1", 0);
//		Tcl_VarEval(interp, "appLoadOkcFile ", "data/synt2k.okc", 0);

//		g_globals.hier_info->SHOW_BANDS = false;

//	Tcl_VarEval(interp, "SetupDataSummary", 0);
		Tcl_VarEval(interp, "ResetDisplayModes", 0);
//		Tcl_VarEval(interp, "SelectDisplayMode ", "parcoord", 0);
		Tcl_VarEval(interp, "SelectDisplayMode ", "hierarchical", 0);
		Tcl_VarEval(interp, "Window show [W ClusterHierarchyDialog]", 0);
		Tcl_VarEval(interp, "raise [W ClusterHierarchyDialog]", 0);
		Tcl_VarEval(interp, "appTest", 0);
	}

	return TCL_OK;
}


/* SID */
static int appSetPrefetcher(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	Prefetcher = atoi(argv[1]);
	return TCL_OK;
}

/* SID */
static int appSetBrushSemantic(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	BrushSemantic = atoi(argv[1]);
	SetupBrushParameters();
	appRefreshAllCanvas(interp);
	return TCL_OK;
}

static int appSetPrefetchStrategy(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	Prefetch_Strategy = atoi(argv[1]);
	return TCL_OK;
}


/* SID */
int appStartPrefetcher(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	start_prefetcher();
	return TCL_OK;
}

/* SID */
int appStopPrefetcher(ClientData clientdata, Tcl_Interp* interp, int argc,
	char* argv[])
{
	stop_prefetcher();
	return TCL_OK;
}

/* SID */
int appDisplayTime(ClientData clientdata, Tcl_Interp* interp, int argc,
	char* argv[])
{
	//	display_time();
	return TCL_OK;
}



/* SID */
//YS
//here I added comments and one more handler
//please copy complete function
static void appOneChange(ClientData clientData)
{
	TestData* data = (TestData*) clientData;

	/*
		if (DISPLAY_DEBUG)
		{
		printf("EXEC type=%d value=%lf\n", data->type, data->value);
		fflush(stdout);
		}
	*/
	stop_prefetcher();

	//1 means left extent
	if (data->type == 1) {		
		g_globals.hier_info->tree_brush[0] = data->value;		
		appUpdateTreeBrushEntries(data->interp);
		SetupBrushParameters();
		appRefreshAllCanvas(data->interp);
	}

	//2 means right extent
	else if (data->type == 2) {		
		g_globals.hier_info->tree_brush[1] = data->value;		
		appUpdateTreeBrushEntries(data->interp);
		SetupBrushParameters();
		appRefreshAllCanvas(data->interp);
	}

	//3 is changing the level of detail for brushed region
	else if (data->type == 3) {		
		char value[16];
		sprintf(value, "%lf", data->value);
		Tcl_VarEval(data->interp, "SetBrushedRadius ", value, 0);		
		appUpdateClusterRadiusSliders(data->interp);
	}

	//4 is changing the level of detail for the unbrushed region
	else if (data->type == 4) {		
		char value[16];
		sprintf(value, "%lf", data->value);
		Tcl_VarEval(data->interp, "SetClusterRadius ", value, 0);		
		appUpdateClusterRadiusSliders(data->interp);
	}

	//6 is moving the middle brush (must update both left and right)
	else if (data->type == 6) {		
		g_globals.hier_info->tree_brush[0] += data->value;
		g_globals.hier_info->tree_brush[1] += data->value;		
		appUpdateTreeBrushEntries(data->interp);
		SetupBrushParameters();
		appRefreshAllCanvas(data->interp);
	}
	//5 means stop
	else if (data->type == 5) {
		//	display_time();
		free(data);
		return;
		//	Tcl_VarEval(data->interp, "appCloseOkcFile", 0);
		//	exit(0);
	}

	if (Prefetcher)
		start_prefetcher();
	//    if (DISPLAY_DEBUG) puts("DONE");

	free(data);
}
//YE

/* SID */
static int appTest(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	TestData* data;
	FILE* file = fopen("simulation/input", "r");

	//jing 
	//	reset_op_timer();

	//	start_timer();

	for (; ;) {
		data = new TestData;
		if (fscanf(file, "%d %d %lf", &(data->time), &(data->type),
				&(data->value)) <= 0)
			break;
		data->interp = interp;
		Tcl_CreateTimerHandler(data->time, appOneChange, data);
	}

	fclose(file);
	return TCL_OK;
}


static void appInitGlobals()
{
	g_globals.dataset = 0;
	interface_color[BG] = 0xffffff;
	interface_color[TEXT] = 0x000000;
	interface_color[DATA] = 0x61f369;
	interface_color[HIGHLIGHT1] = 0xf20000;
	interface_color[HIGHLIGHT2] = 0xf2f200;
	interface_color[HIGHLIGHT3] = 0x00f2f2;
	interface_color[HIGHLIGHT4] = 0x0000f2;
	interface_color[OVERLAP] = 0x000000;
	interface_color[PAINT] = 0x980098;
	interface_color[GRID1] = 0xff0f0f;
	interface_color[GRID2] = 0x0fff0f;
	interface_color[GRID3] = 0x0f0fff;
	interface_color[GRID4] = 0x0f0fff;
	interface_color[STAT1] = 0x0000ea;
	interface_color[STAT2] = 0xc30000;
	interface_color[BRUSH1] = 0xafafea;
	interface_color[BRUSH2] = 0xafafaf;
	interface_color[BRUSH3] = 0xafaf75;
	interface_color[BRUSH4] = 0xafaf3a;
	interface_color[SBB] = 0xff7138;
}


static int appSetupDataValuesDialog(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset)
		return TCL_OK;

/*
	The way DataValuesDialog works is that the text is nothing but
	empty lines, which is much better than formatting everything
	after the brush is changed. 
	
	BrushMgr::BrushedDataValuesUpdate(...)	is linked to the Tcl script
	and is called whenever the view of the DataValuesText widget changes.
	That function sets the visible lines to their actual contents.
*/
	// PAUL: tk_org
	// Setup the DataValuesTest widget by filling it with empty lines
	// to be formatted when the user open the Brushed Data Values dialog box.

	//Tcl_VarEval(interp, "[W DataValuesText] conf -state normal", 0);
	Tcl_VarEval(interp, "[W DataValuesText] delete 0.0 end", 0);

	BrushMgr * brushMgr = g_globals.dataset->brushMgr;

	// Calculate the sum of the number of lines needed for the text widget
	int linecount = 5;
	for (int op = 0; op < num_oper; ++op)
	{
		if (brush_ops[op].oper & VALUES)
		{
			// Add lines for values
			linecount += brushMgr->BrushOpValues[op].Len();
		}
		if ((brush_ops[op].oper & AVERAGE) && (brushMgr->BrushOpValues[op].Len() != 0))
		{
			// Add a line for the average
			linecount++;
		}
	}

	// PAUL: Tcl_VarEval is used as a walk-around because Tcl_Eval crashes here somehow
	for (int i = 0; i < linecount; ++i)
		Tcl_VarEval(interp, "[W DataValuesText] insert end \"\\n\"", 0);

	// The trick is to call the function that fills in the text lines ourselves, because
	// the Tk widget will not do it unless the scrollbar changes shape. This is done
	// by finding the proper values for BrushedDataValuesUpdate and calling it from here.
	char buf[256];
	//Tcl_Eval(interp, ".dataValues.fra24.scr26 get");

	
	Tcl_VarEval(interp, "[W DataValuesText] yview", 0);
	const char * fracts = Tcl_GetStringResult(interp);
	printf("Setup: fracts = \"%s\"\n", fracts);
	sprintf(buf, "BrushMgr::BrushedDataValuesUpdate %s %d", fracts, linecount);
	Tcl_VarEval(interp, buf,0);

	// PAUL: tk_org
	//Tcl_VarEval(interp, "[W DataValuesText] conf -state disabled", 0);


    

	return TCL_OK;
}


// modified by jing yang. Now it not only refresh all the canvas, but also updata some dialogs. 
void appRefreshAllCanvas(Tcl_Interp* interp, grCanvas* except_this)
{
	Tcl_Eval(interp, "SetupDataValuesDialog");

	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	if (canvas != except_this)
		canvas->Refresh();

	grCanvas* nav = grFindCanvas(interp, "structBrushCanvas");
	if (nav && nav != except_this)
		nav->Refresh();

	grCanvas* interRing = grFindCanvas(interp, "interRingCanvas");
	if (interRing && interRing != except_this) {
		if (g_globals.dim_reduction_info->enable)
			interRing->Refresh();
	}
	grCanvas* parcoordtool = grFindCanvas(interp, "minimapCanvas");
	if (parcoordtool && parcoordtool != except_this)
		parcoordtool->Refresh();

	grCanvas* hist = grFindCanvas(interp, "histoCanvas");
	if (hist && hist != except_this)
		hist->Refresh();

	grCanvas* treemap = grFindCanvas(interp, "treemapCanvas");
	if (treemap && treemap != except_this)
		treemap->Refresh();

	grCanvas* glyphtool = grFindCanvas(interp, "glyphToolboxCanvas");
	if (glyphtool && glyphtool != except_this)
		glyphtool->Refresh();

	grCanvas* stacktool = grFindCanvas(interp, "stackToolboxCanvas");
	if (stacktool && stacktool != except_this)
		stacktool->Refresh();

	grCanvas* pixeltool = grFindCanvas(interp, "pixeltoolboxCanvas");
	if (pixeltool && pixeltool != except_this)
		pixeltool->Refresh();

	grCanvas* aux = grFindCanvas(interp, "auxillaryDisplayCanvas");
	if (aux && aux != except_this)
		aux->Refresh();

	char str[50];   
	strcpy(str, "wm state [W DataSummaryDialog]");
	Tcl_Eval(interp, str);
	if (strcmp(interp->result, "normal") == 0)
		appSetupBrushStatistics(interp);
}

static int appMainCanvasRefresh(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh();
	return TCL_OK;
}

static int appRefreshAllCanvas(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	appRefreshAllCanvas(interp);
	return TCL_OK;
}



void appCanvasInputKeyPress(grCanvas* canvas, int key)
{
	if (canvas->shiftkey) {
		// Go into multiselect mode
		multiSelectSetState(canvas, true);
		return;
	} else if (canvas->controlkey && g_globals.curr_brush->bound_type == Brush::RAMP) {
		canvas->SetCursor("right_ptr");
	}

	switch (key) {
	case 'z':
	case 'Z':
		MagnifyBrushRegion(canvas);
		break;

	case 'a':
	case 'A':
		Demagnify(canvas);
		break;

	case 'e':
	case 'E':
		DSIZE++;
		DSIZE = CLAMP(DSIZE, 1, 10);
		canvas->Refresh();
		break;

	case 'r':
	case 'R':
		DSIZE--;
		DSIZE = CLAMP(DSIZE, 1, 10);
		canvas->Refresh();
		break;

		//start_jing_animate_brush
	case 's':
	case 'S':
		SaveCurrentBrushToSavedBrushList();
		break;

	case 'b':
	case 'B':
		AnimateSavedBrushList(canvas);
		break;

	case 'd':
	case 'D':
		DeleteSavedBrushList();
		break;
		//end_jing_animate_brush


	default:
		break;
	}
}

void appCanvasInputKeyRelease(grCanvas* canvas, int key)
{
	if (key == XK_Shift_L || key == XK_Shift_R) {
		// Exit multiselect mode
		multiSelectSetState(canvas, false);
		return;
	}
	canvas->SetDefaultCursor();
}

static int appSetDoubleBuffer(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (atoi(argv[1]))
		grCanvas::doublebuffer = true;
	else
		grCanvas::doublebuffer = false;
	//    grCanvas::doublebuffer = atoi(argv[1]);
	return TCL_OK;
}


//jingdelete
static int appSetCanvasZoom(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	double zoom = (atof(argv[2]) - 1) / 40. + 1;

	grCanvas* canvas = grFindCanvas(interp, argv[1]);
	assert(canvas);

	canvas->zoom.X = canvas->zoom.Y = zoom;
	canvas->Refresh();

	return TCL_OK;
}

static int appSetCanvasZoomOneDirection(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	double zoom = atof(argv[2]);
	int direct = atoi(argv[3]);
	int mode = atoi(argv[4]);

	grCanvas* canvas = grFindCanvas(interp, argv[1]);

	if (canvas == NULL)
		return TCL_OK;

	if (mode == 0) {
		zoom /= 100.;
		if (zoom <= 0)
			return TCL_OK;
		if (direct == 0) {
			canvas->zoom.X = zoom;
			canvas->Refresh();
		} else {
			canvas->zoom.Y = zoom;
			canvas->Refresh();
		}
	} else {
		if (direct == 0) {
			canvas->zoom.X *= zoom;
			canvas->Refresh();
		} else {
			canvas->zoom.Y *= zoom;
			canvas->Refresh();
		}
	}
	return TCL_OK;
}


static int appGetCanvasZoomOneDirection(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	int direct = atoi(argv[2]);

	grCanvas* canvas = grFindCanvas(interp, argv[1]);

	if (canvas == NULL)
		return TCL_OK;

	double zoom;

	if (direct == 0)
		zoom = canvas->zoom.X;
	else
		zoom = canvas->zoom.Y;

	zoom *= 100;
	char str[50];
	sprintf(str, "%.0lf", zoom);
	Tcl_SetResult(interp, str, TCL_VOLATILE);
	return TCL_OK;
}

static int appDependentDimensionHasChanged(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	int which = 0;
	while ( which<g_globals.dataset->all_dims ) {
		if ( strcmp(g_globals.dataset->all_names[which], argv[1] ) ==0 )
			break;
		which++;
	}
	if ( (which==g_globals.dataset->all_dims) || (dep_dim == which) )
		return TCL_OK;

	dep_dim = which;
	grCanvas* canvas = grFindCanvas(interp, "auxillaryDisplayCanvas");
	assert(canvas);
	cfTreeMapInit();
	canvas->display->CanvasDraw();

	canvas->Refresh();

	return TCL_OK;
}

void appCanvasBrushHasChanged(Tcl_Interp* interp)
{
	if (g_globals.dataset) {
		BrushOperMarkDataset();

		if (g_globals.flatqipixel) {
			g_globals.flatqipixel->SetBrushHasModified();
		}
	}
	//    if (g_globals.btree) hierModifyExtentsByBrushParameters();
}

/*
void appShowCaption(Tcl_Interp *interp, const char *str)
{
//jing
	char stri[50];   
	strcpy(stri, "ClearCaption");
	Tcl_Eval(interp, stri);
//    Tcl_Eval(interp, "ClearCaption");
//jing
	Tcl_VarEval(interp, "ShowCaption \"",str,"\"",0);
} 
*/

void appShowCanvasMessage(Tcl_Interp* interp, const char* str,
	const char* canvasName)
{
	Tcl_VarEval(interp, "ShowCanvasMessage \"", str, "\" ", canvasName, 0);
} 

void appBrushBoundaryCaption(grCanvas* canvas, int axis)
{
	//show current brush status in the message bar
	char caption[1000] = "\0";
	char str[100];
	sprintf(caption, "Brush boundary (%s): ", g_globals.dataset->names[axis]);
	double datay;
	datay = g_globals.curr_brush->Pos(axis) + g_globals.curr_brush->Size(axis) * .5;
	if (g_globals.dataset->nominal_fields[axis] != 0) {
		int value = (int) (datay + 0.5);
		const char* string = g_globals.dataset->nominal_fields[axis]->MapValueToString(value);
		sprintf(str, "%s, ", string);
	} else {
		sprintf(str, "%.2lf, ", datay);
	}
	strcat(caption, str);
	datay = g_globals.curr_brush->Pos(axis) - g_globals.curr_brush->Size(axis) * .5;
	if (g_globals.dataset->nominal_fields[axis] != 0) {
		int value = (int) (datay + 0.5);
		const char* string = g_globals.dataset->nominal_fields[axis]->MapValueToString(value);
		sprintf(str, "%s", string);
	} else {
		sprintf(str, "%.2lf", datay);
	}
	strcat(caption, str);

	appShowCanvasMessage(Togl_Interp(canvas->GetWidget()), caption,
		canvas->name);
}

void appShowInterRingCaption(Tcl_Interp* interp, const char* str)
{
	//jing
	char stri[50];   
	strcpy(stri, "ClearInterRingCaption");
	Tcl_Eval(interp, stri);
	//    Tcl_Eval(interp, "ClearCaption");
	//jing
	Tcl_VarEval(interp, "ShowInterRingCaption \"", str, "\"", 0);
}


static int appInterRingDisplaySelection(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	grCanvas* interRing_canvas = grFindCanvas(interp, "interRingCanvas");
	if (interRing_canvas != NULL) {
		CInterRingDisplay* interRing_display;
		interRing_display = (CInterRingDisplay *) (interRing_canvas->display);
		if (interRing_display != NULL) {
			interRing_display->SBSelection(argv[1]);
		}
	}
	return TCL_OK;
}

/*
// according to size
static int appSizeStructureSelectInterRing(ClientData clientData, 
	Tcl_Interp *interp, int argc, char *argv[])
{
	int threshold = atoi(argv[1]);
	dim_reducer->SizeStructureSelectNode(threshold, true);

	grCanvas *canvas = grFindCanvas(interp,"interRingCanvas");
	if ( canvas )
		canvas->Refresh();

	return TCL_OK;
}
*/


/*static int appRadiusStructureSelectInterRing(ClientData clientData, 
	Tcl_Interp *interp, int argc, char *argv[])
{
	double threshold = atof(argv[1]);
	dim_reducer->RadiusStructureSelectNode(threshold, true);

	grCanvas *canvas = grFindCanvas(interp,"interRingCanvas");
	if ( canvas )
		canvas->Refresh();

	return TCL_OK;
} */


static int appSetNormalStatus(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	g_globals.screen_distortion->distortion_status = false;
	return TCL_OK;
}


static int appSetDistortionStatus(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	g_globals.screen_distortion->distortion_status = true;
	return TCL_OK;
}


static int appResetDistortion(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{	
	g_globals.screen_distortion->Reset();
	g_globals.screen_distortion->InterRingReset();
	appRefreshAllCanvas(interp);
	
	return TCL_OK;
}


static int appSetActiveBrush(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int which = atoi(argv[1]);

	SetActiveBrush(which);

	appCanvasBrushHasChanged(interp);
	appRefreshAllCanvas(interp);
	return TCL_OK;
}

static int appSetBrushEnableState(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int which = atoi(argv[1]);
	//    int state = atoi(argv[2]);
	bool state;
	if (atoi(argv[2]))
		state = true;
	else
		state = false;

	SetBrushEnableState(which, state);

	appCanvasBrushHasChanged(interp);
	appRefreshAllCanvas(interp);
	return TCL_OK;
}

static int appSetBrushDisplayState(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int which = atoi(argv[1]);
	//    int state = atoi(argv[2]);
	bool state;
	if (atoi(argv[2]))
		state = true;
	else
		state = false;

	SetBrushDisplayState(which, state);

	appRefreshAllCanvas(interp);
	return TCL_OK;
}

static int appSetBrushBoundaryType(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int which = atoi(argv[1]);
	int type = atoi(argv[2]);

	SetBrushBoundaryType(which, (type == 0) ? Brush::STEP : Brush::RAMP);
	appCanvasBrushHasChanged(interp);

	//    appRefreshAllCanvas(interp);
	return TCL_OK;
}

static int appSaveMainCanvasImage(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	const char* fname = argv[1];

	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->WriteImage(fname);

	return TCL_OK;
}

static int appGlobalBrushResize(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	const char* how = argv[1];

	if (strcasecmp(how, "max") == 0) {
		g_globals.curr_brush->Resize(0);
	} else if (strcasecmp(how, "half") == 0) {
		//  	  g_globals.curr_brush->Resize(0.5);
		g_globals.curr_brush->Resize(0);
		g_globals.curr_brush->Resize(0.5);
	} else if (strcasecmp(how, "+") == 0) {
		g_globals.curr_brush->Resize(1.1);
	} else if (strcasecmp(how, "-") == 0) {
		g_globals.curr_brush->Resize(0.9);
	} else if (strcasecmp(how, "allmin") == 0) {
		for (int i=0; i<g_globals.dataset->dims; ++i) {
			g_globals.curr_brush->SetMinMax(i, g_globals.dataset->dim_min[i], 
											   g_globals.dataset->dim_min[i]);
		}
	} else if (strcasecmp(how, "allmax") == 0) {
		for (int i=0; i<g_globals.dataset->dims; ++i) {
			g_globals.curr_brush->SetMinMax(i, g_globals.dataset->dim_max[i], 
				g_globals.dataset->dim_max[i]);
		}
	}

	appCanvasBrushHasChanged(interp);
	appRefreshAllCanvas(interp);

	return TCL_OK;
}


static int appSetClusterRadius(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset || !g_globals.btree)
		return TCL_OK;

	double val = atof(argv[1]);
	if (val == g_globals.hier_info->cluster_radius)
		return TCL_OK;

	g_globals.hier_info->cluster_radius = val;

	double root_radius = g_globals.hier_info->root_radius; //g_globals.btree->nodes[0].sqrt_radius;
	hierMarkContourNodes(root_radius * g_globals.hier_info->cluster_radius, IS_CONTOUR0);

	appRefreshAllCanvas(interp);

	return TCL_OK;
}

static int appSetBrushedRadius(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset || !g_globals.btree)
		return TCL_OK;

	double val = atof(argv[1]);
	if (val == g_globals.hier_info->brushed_radius)
		return TCL_OK;

	g_globals.hier_info->brushed_radius = val;

	double root_radius = g_globals.hier_info->root_radius; // g_globals.btree->nodes[0].sqrt_radius;
	hierMarkContourNodes(root_radius * g_globals.hier_info->brushed_radius, IS_CONTOUR1);

	if (g_globals.flat_info->flat_sb_brush)
		BrushOperMarkDataset();

	appRefreshAllCanvas(interp);

	return TCL_OK;
}


static int appSetBandsOnOff(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (atoi(argv[1]))
		g_globals.hier_info->SHOW_BANDS = true;
	else
		g_globals.hier_info->SHOW_BANDS = false;
	//    hier_info->SHOW_BANDS = atoi(argv[1]);

	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh();

	return TCL_OK;
}


static int appSetDimReductionDisagreePresent(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	bool show_two_axes;
	bool show_bands;
	bool show_wide_axes;

	if (atoi(argv[1]))
		show_two_axes = true;
	else
		show_two_axes = false;

	if (atoi(argv[2]))
		show_bands = true;
	else
		show_bands = false;

	if (atoi(argv[3]))
		show_wide_axes = true;
	else
		show_wide_axes = false;

	//    bool show_two_axes = atoi(argv[1]);
	//    bool show_bands = atoi(argv[2]);
	if (show_two_axes)
		g_globals.dim_reduction_info->disagree_present = TWOAXES;
	else if (show_bands)
		g_globals.dim_reduction_info->disagree_present = MEANBANDS;
	else if (show_wide_axes)
		g_globals.dim_reduction_info->disagree_present = WIDEAXES;
	else
		g_globals.dim_reduction_info->disagree_present = OMIT;

	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh();

	return TCL_OK;
}


static int appMagnify(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);

	MagnifyBrushRegion(canvas);

	return TCL_OK;
}

static int appDeMagnify(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);

	Demagnify(canvas);

	return TCL_OK;
}

static int appSetExtentScalingFactor(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	g_globals.hier_info->extent_scaling_fac = atof(argv[1]) / 100.;
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	if (canvas != NULL)
		canvas->Refresh();

	return TCL_OK;
}

static int appSetTreeBrush(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int which = atoi(argv[2]);
	double value = atof(argv[1]);

	if (which == 0) {
		if (value >= g_globals.hier_info->tree_brush[1])
			g_globals.hier_info->tree_brush[0] = g_globals.hier_info->tree_brush[1];
		else if (value < 0)
			g_globals.hier_info->tree_brush[0] = 0;
		else
			g_globals.hier_info->tree_brush[0] = value;
	} else {
		if (value <= g_globals.hier_info->tree_brush[0])
			g_globals.hier_info->tree_brush[1] = g_globals.hier_info->tree_brush[0];
		else if (value > 1)
			g_globals.hier_info->tree_brush[1] = 1;
		else
			g_globals.hier_info->tree_brush[1] = value;
	}

	appUpdateTreeBrushEntries(interp);
	SetupBrushParameters();
	appRefreshAllCanvas(interp);

	return TCL_OK;
}

static int appSetDimReductionExtentScalingFactor(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	g_globals.dim_reduction_info->extent_scaling_fac = atof(argv[1]) / 100.;

	appRefreshAllCanvas(interp);

	return TCL_OK;
}


static int appSetDynamicMaskingScale(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	g_globals.hier_info->fade_factor = atof(argv[1]);
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	if (canvas != NULL)
		canvas->Refresh();

	return TCL_OK;
}

void appCanvasMousePan(grCanvas* canvas)
{
	Vec2 motion = canvas->MapScreenToData(canvas->curr_pos) -
				  canvas->MapScreenToData(canvas->prev_pos);
	canvas->translate = canvas->translate + motion;

	//jing
	char stri[50];   
	strcpy(stri, "CanvasVertScrollCmd sync");
//    Tcl_Eval(Togl_Interp(canvas->GetWidget()),"CanvasVertScrollCmd sync");
//    Tcl_Eval(Togl_Interp(canvas->GetWidget()),"CanvasHorizScrollCmd sync");
	Tcl_Eval(Togl_Interp(canvas->GetWidget()), stri);
	strcpy(stri, "CanvasHorizScrollCmd sync");
	Tcl_Eval(Togl_Interp(canvas->GetWidget()), stri);
	//jing

	canvas->Refresh();
}

void appSetupBrushStatistics(Tcl_Interp* interp)
{
	Tcl_Eval(interp, "SetupBrushStats");
}

void appRefreshGlyphPlacementDialog(Tcl_Interp* interp)
{
	Tcl_Eval(interp, "RefreshGlyphPlacement");
}

static int appGetBrushOpString(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int op_num = atoi(argv[1]) - 1;
	if (op_num >= num_oper)
		return TCL_OK;
	Tcl_SetResult(interp, (char *) BrushOperGenerateString(atoi(argv[1]) - 1),
		TCL_STATIC);
	return TCL_OK;
}

static int appGetGlyphPlacementInfo(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	char mode[20], str[100];
	switch (g_globals.flat_info->glyph_place) {
	case ORIGINAL:
		sprintf(mode, "original");
		break;
	case ORDERED:
		sprintf(mode, "ordered");
		break;
	case DATA_DRIVEN:
		sprintf(mode, "data_driven");
		break;
	case DERIVED:
		sprintf(mode, "derived");
		break;
	}

	sprintf(str, "%s %d %d %d", mode, g_globals.flat_info->increase, g_globals.flat_info->space,
		g_globals.flat_info->reduce_overlap);
	Tcl_SetResult(interp, str, TCL_STATIC);
	return TCL_OK;
}


static int appGetInterRingDisplayInfo(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	grCanvas* interRing_canvas = grFindCanvas(interp, "interRingCanvas");
	assert(interRing_canvas);

	CInterRingDisplay* interRing_display = (CInterRingDisplay*)
		(interRing_canvas->display);
	assert(interRing_display);

	int int0, int1, int2, int3, int4;

	int0 = interRing_display->circular_distortion_with_pin ? 1 : 0;
	int1 = interRing_display->circular_distortion_feedback ? 1 : 0;
	int2 = interRing_display->rollup_drilldown_feedback ? 1 : 0;
	int3 = interRing_display->show_selected_name ? 1 : 0;
	// int4 = interRing_display->space_dimension? 1:0;
	int4 = g_globals.screen_distortion->spacing ? 1 : 0;

	char str1[20];
	if (interRing_display->selection_mode == RADIUS_MODE)
		sprintf(str1, "radius_mode");
	else
		sprintf(str1, "entries_mode");

	char str2[20];
	if (interRing_display->brushing_mode == COVER_ALL)
		sprintf(str2, "cover_all");
	else
		sprintf(str2, "filter_out");

	char str[40];
	sprintf(str, "%d %d %d %d %d %s %s", int0, int1, int2, int3, int4, str1,
		str2);
	Tcl_SetResult(interp, str, TCL_STATIC);
	return TCL_OK;
}


static int appNewBrushOps(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	int op_num = BrushOperNew();
	char str[5];
	sprintf(str, "%d", op_num);
	Tcl_SetResult(interp, str, TCL_STATIC);

	/*  if (g_globals.dataset) BrushOperMarkDataset(); // Need to recolor the points
		grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
		assert(canvas);
		canvas->Refresh();
	*/
	return TCL_OK;
}

/*
static int appUpdataDisplays(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
	appCanvasBrushHasChanged(interp);
	appRefreshAllCanvas(interp);
	return TCL_OK;
}
*/

static int appDeleteBrushOps(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int op_num = atoi(argv[1]) - 1;
	BrushOperDelete(op_num);

	appCanvasBrushHasChanged(interp);
	appRefreshAllCanvas(interp);

	return TCL_OK;
}

static int appGetBrushOps(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	static char buf[10];
	strcpy(buf, "");
	BrushOperation* op = &brush_ops[atoi(argv[1]) - 1];

	assert(op);

	// Append the operation(s)
	if (op->oper & HIGH)
		strcat(buf, "1 ");
	else if (op->oper & MASK)
		strcat(buf, "0 ");
	else
		strcat(buf, "-1 ");

	if (op->oper & VALUES)
		strcat(buf, "1 ");
	else
		strcat(buf, "0 ");

	if (op->oper & AVERAGE)
		strcat(buf, "1 ");
	else
		strcat(buf, "0 ");

	Tcl_SetResult(interp, buf, TCL_STATIC);
	return TCL_OK;
}

static int appGetNumBrushes(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	BrushOperation* op = &brush_ops[atoi(argv[1]) - 1];
	assert(op);

	static char brushes[5] = "";
	strcpy(brushes, "");
	sprintf(brushes, "%d", op->num_brush);
	Tcl_SetResult(interp, brushes, TCL_STATIC);
	return TCL_OK;
}

static int appGetBrushExpr(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	static char buf[100];
	strcpy(buf, "");
	BrushOperation* op = &brush_ops[atoi(argv[1]) - 1];
	int idx = atoi(argv[2]) - 1;
	assert(op);

	// Add a NOT if necessary
	if (op->xnot[idx])
		strcat(buf, "1 ");
	else
		strcat(buf, "0 ");

	// Add the brush number
	char str[5];
	sprintf(str, "%d ", op->brush[idx] + 1);
	strcat(buf, str);

	// Add a conjunction if there are more brushes
	if (idx < op->num_brush - 1) {
		switch (op->conj[idx]) {
		case AND:
			strcat(buf, "1 ");
			break;
		case OR:
			strcat(buf, "2 ");
			break;
		case XOR:
			strcat(buf, "3 ");
			break;
		}
	}

	Tcl_SetResult(interp, buf, TCL_STATIC);
	return TCL_OK;
}

static int appFormBrushExpr(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int cur_op = atoi(argv[1]) - 1;

	brush_ops[cur_op].num_brush = 0;

	brush_ops[cur_op].oper = 0;

	if (strcmp(argv[2], "highlight") == 0)
		brush_ops[cur_op].oper = HIGH;

	if (strcmp(argv[2], "mask") == 0)
		brush_ops[cur_op].oper = MASK;

	if (atoi(argv[3])) {
		BITSET(brush_ops[cur_op].oper, VALUES);
	}

	if (atoi(argv[4])) {
		BITSET(brush_ops[cur_op].oper, AVERAGE);
	}

	int i;
	for (i = 0; i < MAXBRUSH; i++) {
		brush_ops[cur_op].xnot[i] = atoi(argv[i + 5]);
	}

	for (i = 0; i < MAXBRUSH; i++) {
		if (atoi(argv[i + 9]))
			brush_ops[cur_op].num_brush++;
		brush_ops[cur_op].brush[i] = atoi(argv[i + 9]) - 1;
	}

	for (i = 0; i < MAXBRUSH - 1; i++) {
		if (strcmp(argv[i + 13], "and") == 0)
			brush_ops[cur_op].conj[i] = AND;

		if (strcmp(argv[i + 13], "or") == 0)
			brush_ops[cur_op].conj[i] = OR;

		if (strcmp(argv[i + 13], "xor") == 0)
			brush_ops[cur_op].conj[i] = XOR;
	}

	if (brush_ops[cur_op].oper != 0)
		appCanvasBrushHasChanged(interp);

	appRefreshAllCanvas(interp);

	return TCL_OK;
}


static int appLowerOperPriority(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	BrushOperLowerPriority(atoi(argv[1]) - 1);

	if (g_globals.dataset)
		BrushOperMarkDataset(); // Need to recolor the points
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh();
	return TCL_OK;
}

static int appRaiseOperPriority(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	BrushOperRaisePriority(atoi(argv[1]) - 1);

	if (g_globals.dataset)
		BrushOperMarkDataset(); // Need to recolor the points
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh();
	return TCL_OK;
}

static int appDrawBrushStatsCanvas(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset)
		return TCL_OK;
	int which = atoi(argv[1]);
	const char* where = argv[2];

	Tcl_CmdInfo infoPtr;
	if (Tcl_GetCommandInfo(interp, (char *) where, &infoPtr) == 0) {
		return 0;
	}
	Tk_Canvas canvas = (Tk_Canvas) infoPtr.clientData;
	assert(canvas);

	statsPlotBrushCoverage(interp, canvas, where, which);

	char str[100];
	sprintf(str, "%lf %lf", g_globals.curr_brush->Min(which), g_globals.curr_brush->Max(which));
	Tcl_Obj *obj = Tcl_NewStringObj(str, -1);
	Tcl_SetObjResult(interp, obj);
//	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}

static int appGetDatasetSummary(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset || g_globals.dataset->datafile == NULL) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}
	/*
	char full_path[200];
	//    realpath(g_globals.dataset->datafile, full_path);
	//jing
	strcpy(full_path, g_globals.dataset->datafile);
	//jing
	char* short_name = strrchr(full_path, '/');
	*short_name = '\0';
	short_name++;
	*/
	struct stat buf;
	stat(g_globals.dataset->datafile, &buf);

	char str[1000];
	sprintf(str, "%d %d %d", /*short_name, full_path, */int(buf.st_size),
		g_globals.dataset->data_size, g_globals.dataset->all_dims);
	Tcl_Obj *obj = Tcl_NewStringObj(str, -1);
	Tcl_SetObjResult(interp, obj);
//	Tcl_SetResult(interp, str, TCL_VOLATILE);

	return TCL_OK;
}

static int appGetShortName(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset || g_globals.dataset->datafile == NULL) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}
	
	char full_path[200];
	strcpy(full_path, g_globals.dataset->datafile);
	char* short_name = strrchr(full_path, '/');
	short_name++;

	Tcl_Obj *obj = Tcl_NewStringObj(short_name, -1);
	Tcl_SetObjResult(interp, obj);

	return TCL_OK;
}

static int appGetFullPath(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset || g_globals.dataset->datafile == NULL) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}
	
	char full_path[200];
	strcpy(full_path, g_globals.dataset->datafile);
	char* short_name = strrchr(full_path, '/');
	*short_name = '\0';

	Tcl_Obj *obj = Tcl_NewStringObj(full_path, -1);
	Tcl_SetObjResult(interp, obj);

	return TCL_OK;
}

static int appGetDimensionName(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset)
		return TCL_OK;

	int which = atoi(argv[1]);
	if (which < 0 || which >= g_globals.dataset->all_dims) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	Tcl_SetResult(interp, g_globals.dataset->names[which], TCL_STATIC);

	return TCL_OK;
}

static int appGetFlatInfo(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "Predefined Uniform", TCL_STATIC);
		return TCL_OK;
	}

	char str[200];
	strcpy(str, g_globals.flat_info->colorscale);
	strcat(str, " ");
	strcat(str, g_globals.flat_info->colorassigned.colorprefer);

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}

static int appGetDimensionNames(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	// PAUL: bug
	// This tends to crash for huge data sets
	//char str[1000];
	char str[100000];
	strcpy(str, g_globals.dataset->all_names[0]);
	for (int i = 1; i < g_globals.dataset->all_dims; i++) {
		strcat(str, " ");
		strcat(str, g_globals.dataset->all_names[i]);
	}

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}


static int appGetPrincipalNames(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int i, prin_num;
	char** prin_names;
	if (g_globals.dataset->dims < 3)
		prin_num = g_globals.dataset->dims;
	else
		prin_num = 3;
	prin_names = new char * [prin_num];

	char name_num[2];
	for (i = 0; i < prin_num; i++) {
		prin_names[i] = new char[20];
		strcpy(prin_names[i], "Principal_Component_");
		sprintf(name_num, "%d", i);
		strcat(prin_names[i], name_num);
	}

	char str[200];
	strcpy(str, prin_names[0]);
	for (i = 1; i < prin_num; i++) {
		strcat(str, " ");
		strcat(str, prin_names[i]);
	}

	Tcl_SetResult(interp, str, TCL_VOLATILE);

	return TCL_OK;
}

static int appGetFieldInfo(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	if (which < 0 || which >= g_globals.dataset->all_dims) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	ARR< char*> temp_names(g_globals.dataset->all_dims);
	ARR< double> temp_dim_min(g_globals.dataset->all_dims);
	ARR< double> temp_dim_max(g_globals.dataset->all_dims);

	g_globals.dataset->MapDataWithoutOnOff(g_globals.dataset->all_names, temp_names);
	g_globals.dataset->MapDataWithoutOnOff(g_globals.dataset->all_dim_min, temp_dim_min);
	g_globals.dataset->MapDataWithoutOnOff(g_globals.dataset->all_dim_max, temp_dim_max);

	char str[200];
	sprintf(str, "%s %lf %lf", temp_names[which], temp_dim_min[which],
		temp_dim_max[which]);
	Tcl_Obj *obj = Tcl_NewStringObj(str, -1);
	Tcl_SetObjResult(interp, obj);

	return TCL_OK;
}

static int appGetDimensionInfo(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	if (which < 0 || which >= g_globals.dataset->all_dims) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}
	// to change? JingJing
	ARR< char*> temp_names(g_globals.dataset->all_dims);

	g_globals.dataset->MapDataWithoutOnOff(g_globals.dataset->all_names, temp_names);

	char str[200];
	sprintf(str, "%s %d", temp_names[which], g_globals.dataset->on[which]);

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}


static int appGetClusterBrush(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int i; 
	if (g_globals.hier_info->SHOW_BANDS)
		i = 1;
	else
		i = 0;

	char str[200];
	sprintf(str, "%d %lf %lf %lf %lf %lf %lf", i, g_globals.hier_info->cluster_radius,
		g_globals.hier_info->brushed_radius, g_globals.hier_info->fade_factor,
		100 - g_globals.hier_info->extent_scaling_fac * 100, g_globals.hier_info->tree_brush[0],
		g_globals.hier_info->tree_brush[1]);

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}

static int appGetDimReductionToolbox(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	int i, j, k; 

	if (g_globals.dim_reduction_info->disagree_present == TWOAXES)
		i = 1;
	else
		i = 0;

	if (g_globals.dim_reduction_info->disagree_present == MEANBANDS)
		j = 1;
	else
		j = 0;

	if (g_globals.dim_reduction_info->disagree_present == WIDEAXES)
		k = 1;
	else
		k = 0;

	char str[200];
	sprintf(str, "%d %d %d %lf", i, j, k,
		100 - g_globals.dim_reduction_info->extent_scaling_fac * 100);

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}


static int appInterRingDisplayReorder(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	grCanvas* interRing_canvas = grFindCanvas(interp, "interRingCanvas");
	if (interRing_canvas != NULL) {
		CInterRingDisplay* interRing_display;
		interRing_display = (CInterRingDisplay *) (interRing_canvas->display);
		if (interRing_display != NULL) {
			interRing_display->GetTree()->Reorder();
			interRing_display->GetTree()->ResetAngles();
		}
		interRing_canvas->Refresh(true);
	}
	return TCL_OK;
}


static int appSetInterRingDisplayParameter(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{	
	grCanvas* interRing_canvas = grFindCanvas(interp, "interRingCanvas");
	if (interRing_canvas != NULL) {
		CInterRingDisplay* interRing_display;
		interRing_display = (CInterRingDisplay *) (interRing_canvas->display);
		if (interRing_display != NULL) {
			if (strcmp(argv[1], "selection_mode") == 0) {
				if (strcmp(argv[2], "radius_mode") == 0)
					interRing_display->selection_mode = RADIUS_MODE;
				else
					interRing_display->selection_mode = ENTRIES_MODE;
			} else if (strcmp(argv[1], "brushing_mode") == 0) {
				if (strcmp(argv[2], "cover_all") == 0)
					interRing_display->brushing_mode = COVER_ALL;
				else
					interRing_display->brushing_mode = FILTER_OUT;
			} else {
				bool value;
				if (atoi(argv[2]) == 1)
					value = true;
				else
					value = false;

				if (strcmp(argv[1], "circular_distortion_with_pin") == 0)
					interRing_display->circular_distortion_with_pin = value;
				else if (strcmp(argv[1], "circular_distortion_feedback") == 0)
					interRing_display->circular_distortion_feedback = value;
				else if (strcmp(argv[1], "rollup_drilldown_feedback") == 0)
					interRing_display->rollup_drilldown_feedback = value;
				else if (strcmp(argv[1], "show_selected_name") == 0)
					interRing_display->show_selected_name = value;
				else if (strcmp(argv[1], "space_dimension") == 0) {
					g_globals.screen_distortion->spacing = value;
					g_globals.screen_distortion->Reset();
				}
				interRing_canvas->Refresh();
			}
		}
	}
	
	return TCL_OK;
}


static int appSetFieldOnOff(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (g_globals.dim_reducer != NULL && g_globals.dim_reducer->status != NORMAL)
		return TCL_OK;

	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	//    int state = atoi(argv[2]);
	bool state;
	if (atoi(argv[2]))
		state = true;
	else
		state = false;

	g_globals.dataset->SetFieldOnOff(which, state);


	// PAUL: brush_org
	// Do work after okcdata does its thing
	// This ensures that brush contents are updated with the least
	// amount of work necessary.
	if (state)
		g_globals.dataset->brushMgr->EnableDim(which);
	else
		g_globals.dataset->brushMgr->DisableDim(which);


	appRefreshGlyphPlacementDialog(interp);

	//    if (g_globals.btree) hierSetMeanOnOff();

	appCanvasBrushHasChanged(interp);

	
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	// added by debbie
	
	char* type = canvas->currType;

	if(g_globals.dataset->dims != g_globals.dataset->all_dims)       
		Tcl_Eval(interp, "::.dimensionReorder::GreyOutDimensionReorder");
	else if(!strcmp(type, "pa")||!strcmp(type, "sc")||!strcmp(type, "st")||!strcmp(type, "di"))
		Tcl_Eval(interp, "::.dimensionReorder::EnableDimensionReorder");

	// added by debbie

	canvas->Refresh();

	Tcl_Eval(interp, "SetupDataSummary");

	Tcl_Eval(interp, "SetupDimensionOnOffReorder");
	//Added by Zaixian begin
	Tcl_Eval(interp, "::.pixWeights::SetupWeightsCanvas");
	//Zaixian end

	
	return TCL_OK;
}

static int appReorderDimension(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (g_globals.dim_reducer != NULL && g_globals.dim_reducer->status != NORMAL)
		return TCL_OK;

	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	int forward = atoi(argv[2]);

	g_globals.dataset->ReorderDimension(which, forward);

	appCanvasBrushHasChanged(interp);

	Tcl_Eval(interp, "SetupDataSummary");
	//jing
	Tcl_Eval(interp, "SetupDimensionOnOffReorder");

	Tcl_Eval(interp, "SetupGlyphKeyDialog");

	Tcl_Eval(interp, "SetupDimStackKeyDialog");

	Tcl_Eval(interp, "SetupBrushStats");
	//Added by Zaixian begin
	Tcl_Eval(interp, "::.pixWeights::SetupWeightsCanvas");
	Tcl_Eval(interp, "::.binNumber::SetupBinsNumberCanvas");
	//Zaixian end
	//    Tcl_Eval(interp,"SetupDimReductionToolbox");
	//jing
	//    Tcl_Eval(interp,"SetupDependentDimensionsMenu");

	appRefreshAllCanvas(interp);
	/*
		grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
		assert(canvas);
		canvas->Refresh();
	*/
	return TCL_OK;
}



//Added by Debbie
static int appSimilarityBasedReorder(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!g_globals.dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

	// param is defined in OrderDimension.h

	g_globals.reorderParameters = (Reorder_Parameters *)malloc(sizeof(Reorder_Parameters));
	g_globals.reorderParameters->algorithm = atoi(argv[1]);
    g_globals.reorderParameters->brushed = atoi(argv[2]);
	g_globals.reorderParameters->correlation = atoi(argv[3]);
	g_globals.reorderParameters->min_max = atoi(argv[4]);
	g_globals.reorderParameters->nn_start_dim = atoi(argv[5]);
	g_globals.reorderParameters->interp = interp;
	g_globals.dataset->Similarity_Based_Reorder();

	free(g_globals.reorderParameters);
	g_globals.reorderParameters = NULL;
    appRefreshAllCanvas(interp);

    return TCL_OK;
}

//Added by debbie
static int appClutterBasedReorder(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
     
	if (!g_globals.dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }
	


    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);

	// param is defined in OrderDimension.h

	g_globals.reorderParameters = (Reorder_Parameters *)malloc(sizeof(Reorder_Parameters));

	g_globals.reorderParameters->canvas = canvas;
	g_globals.reorderParameters->algorithm = atoi(argv[1]);
	g_globals.reorderParameters->brushed = atoi(argv[2]);
	g_globals.reorderParameters->min_max = atoi(argv[3]);
	g_globals.reorderParameters->threshold_1 = atof(argv[4]);
	g_globals.reorderParameters->threshold_2 = atof(argv[5]);
	g_globals.reorderParameters->nn_start_dim = atoi(argv[6]);
	g_globals.reorderParameters->eight_connected = atoi(argv[7]);
	g_globals.reorderParameters->interp = interp;

	canvas->display->ClutterBasedOrder();
	
	free(g_globals.reorderParameters);
	g_globals.reorderParameters = NULL;

    appRefreshAllCanvas(interp);

//   dataset->draw_outlier = false;
 //  for ( int i = 0; i < dataset->data_size; i ++ )
//	   dataset->global_flag[i] = true;


    return TCL_OK;
}

//Added by Debbie
static int appGetThresholdRange(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}
	grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
	
	char str[200];
	double min_1, max_1, min_2, max_2;
	if(!strcmp(canvas->currType,"pa"))
	{
		min_1 = 0;
		max_1 = sqrt(1.0+1.0); // maximum normalized euclidean distance possible
		min_2 = 0;         // not used
		max_2 = 100;       // not used
		sprintf(str, "%f %f %f %f", min_1, max_1, min_2, max_2);
	}
	else if(!strcmp(canvas->currType, "sc"))
	{
		min_1 = 0;
		max_1 = 2; // maximum pearson correlation difference possible
		min_2 = 0;
		max_2 = 1./2;
		sprintf(str, "%f %f %f %f", min_1, max_1, min_2, max_2);
	}
	else if(!strcmp(canvas->currType, "st"))
	{
		min_1 = 0;
		max_1 = 1;
		min_2 = 0;
		max_2 = 1;
		sprintf(str, "%f %f %f %f", min_1, max_1, min_2, max_2);

	}
	else if(!strcmp(canvas->currType, "di"))
	{
		min_1 = 1;  // smallest group
		max_1 = pow((double)(g_globals.dataset->cardinality[0]),(int)2);
		min_2 = 0;       // not used
		max_2 = 100;     // not used
		sprintf(str, "%f %f %f %f", min_1, max_1, min_2, max_2);
	}

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}

//Added by Debbie
static int appGetDefaultThreshold(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}
	grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
	
	char str[200];
	double threshold_1, threshold_2;
	if(!strcmp(canvas->currType,"pa"))
	{
		threshold_1 = 0.1;
		threshold_2 = 0;       // not used
		sprintf(str, "%f %f", threshold_1, threshold_2);
	}
	else if(!strcmp(canvas->currType, "sc"))
	{
		threshold_1 = 0.5;
		threshold_2 = 0.25;
		sprintf(str, "%f %f", threshold_1, threshold_2);
	}
	else if(!strcmp(canvas->currType, "st"))
	{
		threshold_1 = 0.1;
		threshold_2 = 0.1;
		sprintf(str, "%f %f", threshold_1, threshold_2);

	}
	else if(!strcmp(canvas->currType, "di"))
	{
		threshold_1 = 2;		// number of aggregated bins in one group
		threshold_2 = 0;		// not used
		sprintf(str, "%f %f", threshold_1, threshold_2);
	}

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}

//Added by Debbie
static int appGetActiveDimension(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}
	
	int result;
    if(g_globals.dataset->dims != g_globals.dataset->all_dims)   
		result = 0;
	else
		result = 1;

	char str[200];
	sprintf(str, "%d", result);
	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}

static int appGlyphPlacementSort(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	const char* name = argv[1];

	//    int increase = atoi(argv[2]);
	bool increase;
	if (atoi(argv[2]))
		increase = true;
	else
		increase = false;

	//    int space = atoi(argv[3]);
	bool space;
	if (atoi(argv[3]))
		space = true;
	else
		space = false;

	bool success = false;
	int dimnumber;
	for (int i = 0; i < g_globals.dataset->all_dims; i++) {
		if (strcmp(name, g_globals.dataset->all_names[i]) == 0) {
			success = true;
			dimnumber = i;
			break;
		}
	}

	if (success) {
		g_globals.flat_info->glyph_place = ORDERED;
		g_globals.flat_info->increase = increase;
		g_globals.flat_info->space = space;

		if (space)
			g_globals.dataset->Placement_Sort_Space_Glyph(dimnumber, increase);
		else
			g_globals.dataset->Placement_Sort_Glyph(dimnumber, increase);
		appRefreshAllCanvas(interp);
	}
	return TCL_OK;
}


static int appSetInterRingDisplayActionMode(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	grCanvas* interRing_canvas = grFindCanvas(interp, "interRingCanvas");
	if (interRing_canvas != NULL) {
		CInterRingDisplay* interRing_display;
		interRing_display = (CInterRingDisplay *) (interRing_canvas->display);
		if (interRing_display != NULL)
			interRing_display->SetActionMode(argv[1]);
	}

	return TCL_OK;
}

static int appSetDimReductionStatus(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int result;
	if (g_globals.dim_reducer != NULL)
		result = g_globals.dim_reducer->SetStatus(argv[1]);
	if (result >= 0)
		appRefreshAllCanvas(interp);

	// added by debbie
	grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
	char* type = canvas->currType;

	if(g_globals.dataset->dims != g_globals.dataset->all_dims)       
		Tcl_Eval(interp, "::.dimensionReorder::GreyOutDimensionReorder");
	else if(!strcmp(type, "pa")||!strcmp(type, "sc")||!strcmp(type, "st")||!strcmp(type, "di"))
		Tcl_Eval(interp, "::.dimensionReorder::EnableDimensionReorder");

	// added by debbie

	//jing handle messages 
	char stri[100];   
	strcpy(stri, "");

	if (result == 1)
		strcpy(stri, "Correct selection has been applied successfully.");
	else if (result == -1)
		strcpy(stri, "Correct selection has already been applied.");
	else if (result == -2)
		strcpy(stri, "No dimension has been selected.");
	else if (result == -3)
		strcpy(stri, "Too many dimensions have been selected.");

	appShowCanvasMessage(interp, stri, "interRingCanvas");

	return TCL_OK;
}

// NEW - zfc
static int appGlyphShapeOriginal(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	g_globals.flat_info->Shape_Original_Glyph();
	appRefreshAllCanvas(interp);
	return TCL_OK;
}
// NEW - zfc

// NEW - zfc
static int appGlyphShapeNew(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	g_globals.flat_info->Shape_New_Glyph();
	appRefreshAllCanvas(interp);
	return TCL_OK;
}
// NEW - zfc

//jing - set the mode of how to assign colors of the axis when applying dimenison reduction.
//original mode - all axes have the same color as in orginal flat display.
//node_color mode - axes' colors are their color in the dim hierarchical tree.
static int appSetDimReductionAxisColor(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	g_globals.dim_reducer->SetAxisColorStrategy(argv[1]);
	g_globals.dim_reducer->ResetAxisColor();

	appRefreshAllCanvas(interp);

	return TCL_OK;
}


static int appInterRingDisplayReset(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	grCanvas* interRing_canvas = grFindCanvas(interp, "interRingCanvas");
	if (interRing_canvas != NULL) {
		CInterRingDisplay* interRing_display;
		interRing_display = (CInterRingDisplay *) (interRing_canvas->display);
		if (interRing_display != NULL) {
			CInterRingClusterTree* tree = interRing_display->GetTree();
			if (tree != NULL) {
				if (strcmp(argv[1], "color") == 0) {
					tree->ResetColors();
					if (g_globals.dim_reducer != NULL) {
						g_globals.dim_reducer->ResetAxisColor();
						appRefreshAllCanvas(interp);
					}
				} else if (strcmp(argv[1], "cir_distortion") == 0) {
					tree->ResetAngles();
					g_globals.screen_distortion->Reset();
				} else if (strcmp(argv[1], "rad_distortion") == 0)
					interRing_display->ResetRadius();
				else if (strcmp(argv[1], "selection") == 0) {
/*					g_globals.dim_reducer->SetStatus("normal"); 	   
					if ( g_globals.dim_reducer != NULL )
					   	g_globals.dim_reducer->ResetRepresentativeDimList();
*/  				interRing_display->ResetSelection();
				}
				appRefreshAllCanvas(interp);
			}
		}
	}

	return TCL_OK;

	/*    
		if ( dtree == NULL )
			return TCL_OK;
		if ( strcmp(argv[1], "color") == 0 )
			dtree->ResetColors();
		else if ( strcmp(argv[1], "distortion") == 0 )
			dtree->ResetAngles();
		else if ( strcmp(argv[1], "selection") == 0 )
		{
			g_globals.dim_reducer->SetStatus("normal");   	 
			if ( g_globals.dim_reducer != NULL )
				g_globals.dim_reducer->ResetRepresentativeDimList();
		}
	 */
}


static int appGlyphPlacementOriginal(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int space = atoi(argv[1]);
	if (space)
		g_globals.dataset->Placement_Original_Space_Glyph();
	else
		g_globals.dataset->Placement_Original_Glyph();

	g_globals.flat_info->glyph_place = ORIGINAL;
	g_globals.flat_info->space = space;

	appRefreshAllCanvas(interp);

	return TCL_OK;
}

static int appGlyphPlacementDataDriven(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	const char* name1 = argv[1];
	const char* name2 = argv[2];
	int shift = atoi(argv[3]);

	bool success1 = false;
	bool success2 = false;

	int xdimnumber, ydimnumber;
	for (int i = 0; i < g_globals.dataset->all_dims; i++) {
		char str1[100];//, str2[100]; PAUL: bug
		strcpy(str1, g_globals.dataset->all_names[i]);
		printf("%s\n", str1);
		if (strcmp(name1, g_globals.dataset->all_names[i]) == 0) {
			success1 = true;
			xdimnumber = i;
		}
		if (strcmp(name2, g_globals.dataset->all_names[i]) == 0) {
			success2 = true;
			ydimnumber = i;
		}
	}

	if (success1 && success2) {
		g_globals.flat_info->glyph_place = DATA_DRIVEN;
		g_globals.flat_info->reduce_overlap = shift;

		g_globals.dataset->Placement_DataDriven_Glyph(xdimnumber, ydimnumber);
		if (shift) {
			g_globals.dataset->Placement_Shift_Glyph();
		}
		appRefreshAllCanvas(interp);
	}

	return TCL_OK;
}


static int appGlyphPlacementDerived(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int i, prin_num;
	char** prin_names;
	if (g_globals.dataset->dims < 3)
		prin_num = g_globals.dataset->dims;
	else
		prin_num = 3;
	prin_names = new char * [prin_num];

	char name_num[2];
	for (i = 0; i < prin_num; i++) {
		prin_names[i] = new char[20];
		strcpy(prin_names[i], "Principal_Component_");
		sprintf(name_num, "%d", i);
		strcat(prin_names[i], name_num);
	}

	const char* name1 = argv[1];
	const char* name2 = argv[2];
	int shift = atoi(argv[3]);


	bool success1 = false;
	bool success2 = false;

	int xdimnumber, ydimnumber;
	for (i = 0; i < prin_num; i++) {
		if (strcmp(name1, prin_names[i]) == 0) {
			success1 = true;
			xdimnumber = i + g_globals.dataset->all_dims;
		}

		if (strcmp(name2, prin_names[i]) == 0) {
			success2 = true;
			ydimnumber = i + g_globals.dataset->all_dims;
		}
	}

	for (i = 0; i < g_globals.dataset->all_dims; i++) {
		if (strcmp(name1, g_globals.dataset->all_names[i]) == 0) {
			success1 = true;
			xdimnumber = i;
		}

		if (strcmp(name2, g_globals.dataset->all_names[i]) == 0) {
			success2 = true;
			ydimnumber = i;
		}
	}

	if (success1 && success2) {
		g_globals.flat_info->glyph_place = DERIVED;
		g_globals.flat_info->reduce_overlap = shift;
		g_globals.dataset->Placement_Derived_Glyph(xdimnumber, ydimnumber);
		if (shift) {
			g_globals.dataset->Placement_Shift_Glyph();
		}
		appRefreshAllCanvas(interp);
	}

	return TCL_OK;
}

static int appGetCanvasViewParameters(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	grCanvas* canvas = grFindCanvas(interp, argv[1]);
	assert(canvas);

	Vec2 percent;
	percent.X = 1.0 / canvas->zoom.X;
	percent.Y = 1.0 / canvas->zoom.Y;

	Vec2 org;
	org.X = -canvas->translate.X;
	org.Y = -canvas->translate.Y;

	//if (canvas->origin_at_lower_left) org.Y = 1.0 + canvas->translate.Y - percent.Y;

	char str[100];
	sprintf(str, "%lf %lf %lf %lf", org.X, org.Y, percent.X, percent.Y);
	Tcl_Obj *obj = Tcl_NewStringObj(str, -1);
	Tcl_SetObjResult(interp, obj);
//	Tcl_SetResult(interp, str, TCL_STATIC);
	return TCL_OK;
}

static int appSetViewScrollTo(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	double xorg = atof(argv[2]);
	double yorg = atof(argv[3]);

	grCanvas* canvas = grFindCanvas(interp, argv[1]);
	assert(canvas);

	//if (canvas->origin_at_lower_left) yorg = 1.0 - yorg - 1.0/canvas->zoom.Y;

	canvas->translate.X = -xorg;
	canvas->translate.Y = -yorg;

	canvas->Refresh();

	return TCL_OK;
}

static int appSetDimensionReduction(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	int enable = atoi(argv[1]);

	g_globals.dim_reduction_info->Enable(enable);

	return TCL_OK;
}

static int appQueryGlyphKey(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	if (which < 0 || which >= g_globals.dataset->dims) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	// Compute text strings and place pointers into keylist
	//
	/*    char key_text[500] = "\0";
		for (int i = 0;i < g_globals.dataset->dims;i++) {
			char str[100];
			sprintf(str, "%s: %.1f degrees\n",g_globals.dataset->names[i],i*360./g_globals.dataset->dims);
			strcat(key_text,str);
		}
	*/
	char str[200];
	sprintf(str, "%s: %.1f degrees\n", g_globals.dataset->names[which],
		which * 360. / g_globals.dataset->dims);

	Tcl_SetResult(interp, str, TCL_STATIC);
	return TCL_OK;
}


static int appQueryDimStackKey(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	if (which < 0 || which >= g_globals.dataset->dims) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	char str[200];
	sprintf(str, "   %s: cardinality %d\n", g_globals.dataset->names[which],
		g_globals.dataset->cardinality[which]);

	Tcl_SetResult(interp, str, TCL_STATIC);
	return TCL_OK;
}



static int appRegisterCanvas(Tcl_Interp* interp, const char* canvas_name,
	const char* type)
{
	grCanvas* canvas = grFindCanvas(interp, canvas_name);
	assert(canvas);
	if (!strcmp(canvas_name, "mainCanvas")) {
		if (!g_globals.mainCanvas)
			g_globals.mainCanvas = canvas;
	}
	canvas->SetDefaultCursor();

	if (canvas->display) {
//		delete canvas->display;
		canvas->display = NULL;
		if (strcmp(canvas->currType, "pa") == 0) {
			SAFE_DELETE(g_globals.flatparcoord);
		} else if (strcmp(canvas->currType, "sc") == 0) {
			SAFE_DELETE(g_globals.flatscatter);
		} else if (strcmp(canvas->currType, "st") == 0) {
			SAFE_DELETE(g_globals.flatglyph);
		} else if (strcmp(canvas->currType, "di") == 0) {
			SAFE_DELETE(g_globals.flatdimstack);
		} else if (strcmp(canvas->currType, "qip") == 0) {
			SAFE_DELETE(g_globals.flatqipixel);

		} else if (strcmp(canvas->currType, "hpa") == 0) {
			SAFE_DELETE(g_globals.hierparcoord);
		} else if (strcmp(canvas->currType, "hsc") == 0) {
			SAFE_DELETE(g_globals.hierscatter);
		} else if (strcmp(canvas->currType, "hst") == 0) {
			SAFE_DELETE(g_globals.hierglyph);
		} else if (strcmp(canvas->currType, "hdi") == 0) {
			SAFE_DELETE(g_globals.hierdimstack);
		} else if (strcmp(canvas->currType, "hpi") == 0) {
			SAFE_DELETE(g_globals.hierpixel);

		} else if (strcmp(type, "cfNav") == 0) {
			SAFE_DELETE(g_globals.hiernav);
		} else if (strcmp(type, "cfHist") == 0) {
			SAFE_DELETE(g_globals.hierhist);
		} else if (strcmp(type, "minimap") == 0) {
			SAFE_DELETE(g_globals.parcoordtool);
		} else if (strcmp(type, "treemap") == 0) {
			SAFE_DELETE(g_globals.hiertreemap);
		} else if (strcmp(type, "glyphtoolbox") == 0) {
			SAFE_DELETE(g_globals.glyphtool);
		} else if (strcmp(type, "stacktoolbox") == 0) {
			SAFE_DELETE(g_globals.dimstacktool);
		} else if (strcmp(type, "pixeltoolbox") == 0) {
			SAFE_DELETE(g_globals.pixeltool);
		} else if (strcmp(type, "interRing") == 0) {
			SAFE_DELETE(g_globals.interring);
		} else if (strcmp(type, "cmapeditor") == 0) {
			SAFE_DELETE(g_globals.cmapeditor);
		}
	}

	if (strcmp(type, "pa") == 0) {
		g_globals.flatparcoord = new CFlatParcoord(g_globals.flat_info);
		CFlatParcoord* dis = g_globals.flatparcoord;
		canvas->RegisterDisplay(dis, type); 
		/*  	if (g_globals.dataset && g_globals.btree==0) {
					  int N = strlen(g_globals.dataset->datafile);
					  char* cf_file = new char[N+1];
					  strcpy(cf_file,g_globals.dataset->datafile);
					  strcpy(&cf_file[N-4],".cf");
					  Tcl_VarEval(interp,"LoadClusterFile ",g_globals.dataset->datafile," ",cf_file,0);
					delete cf_file;
				}
				  g_globals.flat_info->flat_sb_brush = true;
				  CMixedDisplay *dis = new CMixedDisplay(g_globals.flat_info, g_globals.hier_info);
				  canvas->RegisterDisplay(dis); */
	} else if (strcmp(type, "sc") == 0) {
		g_globals.flatscatter = new CFlatScatter(g_globals.flat_info);
		CFlatScatter* dis = g_globals.flatscatter;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "st") == 0) {
		g_globals.flatglyph = new CFlatGlyph(g_globals.flat_info);
		CFlatGlyph* dis = g_globals.flatglyph;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "di") == 0) {
		g_globals.flatdimstack = new CFlatDimstack(g_globals.flat_info);
		CFlatDimstack* dis = g_globals.flatdimstack;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type,"qip")==0) {
		g_globals.flatqipixel = new CFlatPixel(g_globals.flat_info);
		CFlatPixel *dis = g_globals.flatqipixel;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "hpa") == 0 ||
			strcmp(type, "hsc") == 0 ||
			strcmp(type,"hst") == 0 ||
			strcmp(type,"hdi") == 0 ||
			strcmp(type,"hpi") == 0) {
		if (g_globals.dataset && g_globals.btree == 0) {
			int N = strlen(g_globals.dataset->datafile);
			char* cf_file = new char[N + 1];
			strcpy(cf_file, g_globals.dataset->datafile);
			strcpy(&cf_file[N - 4], ".cf");

			Tcl_VarEval(interp, "LoadClusterFile ", g_globals.dataset->datafile, " ",
				cf_file, 0);
			delete [] cf_file;
		}
		if (strcmp(type, "hpa") == 0) {
			g_globals.hierparcoord = new CHierParcoord(g_globals.hier_info);
			CHierParcoord* dis = g_globals.hierparcoord;
			canvas->RegisterDisplay(dis, type);
		} else if (strcmp(type, "hsc") == 0) {
			g_globals.hierscatter = new CHierScatter(g_globals.hier_info);
			CHierScatter* dis = g_globals.hierscatter;
			canvas->RegisterDisplay(dis, type);
		} else if (strcmp(type, "hst") == 0) {
			g_globals.hierglyph = new CHierGlyph(g_globals.hier_info);
			CHierGlyph* dis = g_globals.hierglyph;
			canvas->RegisterDisplay(dis, type);
		} else if (strcmp(type, "hdi") == 0) {
			g_globals.hierdimstack = new CHierDimstack(g_globals.hier_info);
			CHierDimstack* dis = g_globals.hierdimstack;
			canvas->RegisterDisplay(dis, type);
		} else if (strcmp(type, "hpi") == 0) {
			g_globals.hierpixel = new CHierPixel(g_globals.hier_info);
			CHierPixel* dis = g_globals.hierpixel;
			canvas->RegisterDisplay(dis, type);
		}
	} else if (strcmp(type, "cfNav") == 0) {
		g_globals.hiernav = new CHierNav(g_globals.hier_info);
		CHierNav* dis = g_globals.hiernav;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "cfHist") == 0) {
		g_globals.hierhist = new CHierHist(g_globals.hier_info);
		CHierHist* dis = g_globals.hierhist;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "minimap") == 0) {
		g_globals.parcoordtool = new CParcoordTool(g_globals.flat_info);
		CParcoordTool* dis = g_globals.parcoordtool;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "treemap") == 0) {
		g_globals.hiertreemap = new CHierTreemap(g_globals.hier_info);
		CHierTreemap* dis = g_globals.hiertreemap;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "glyphtoolbox") == 0) {
		g_globals.glyphtool = new CGlyphTool(g_globals.flat_info);
		CGlyphTool* dis = g_globals.glyphtool;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "stacktoolbox") == 0) {
		g_globals.dimstacktool = new CDimstackTool(g_globals.flat_info);
		CDimstackTool* dis = g_globals.dimstacktool;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "pixeltoolbox") == 0) {
		g_globals.pixeltool = new CPixelTool(g_globals.flat_info);
		CPixelTool* dis = g_globals.pixeltool;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "interRing") == 0) {
		g_globals.interring = new CInterRingDimDisplay();
		CInterRingDimDisplay* dis = g_globals.interring;
		canvas->RegisterDisplay(dis, type);
	} else if (strcmp(type, "cmapeditor") == 0) {
		g_globals.cmapeditor = new CColorMapEditor();
		CColorMapEditor* dis = g_globals.cmapeditor;
		canvas->RegisterDisplay(dis, type);
	} else {
		std::cerr << "### Undefined display mode: \"" << type << "\".\n";
		assert(true);
	}

	canvas->Refresh();

	return TCL_OK;
}


static int appUnRegisterCanvas(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	grCanvas* canvas = grFindCanvas(interp, argv[1]);
	assert(canvas);

	if (canvas->display) {
		delete canvas->display;
		canvas->display = 0;
	}

	return TCL_OK;
}


static int appRegisterCanvas(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	return appRegisterCanvas(interp, argv[1], argv[2]);
}

static int appModeSelect(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	const char* what = argv[1];

	appRegisterCanvas(interp, "mainCanvas", what);
	//    appRefreshAllCanvas(interp);

	return TCL_OK;
}

static int appCloseOkcFile(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (g_globals.dataset) {
		//start_jing_animate_brush
		if (saved_brush_list != NULL)
			DeleteSavedBrushList();
		//end_jing_animate_brush
		delete g_globals.dataset;
	}

	g_globals.dataset = NULL;

	hierDeleteClusterTree();

	if (g_globals.dim_reducer != NULL) {
		delete g_globals.dim_reducer;
		g_globals.dim_reducer = NULL;
	}

	if (g_globals.dtree != NULL) {
		delete g_globals.dtree;
		g_globals.dtree = NULL;
	}

	Tcl_Eval(interp, "HideDimensionReductionDialog");
	Tcl_Eval(interp, "HideDataSummaryDialog");
	Tcl_Eval(interp, "HideDimensionOnOffReorderDialog");
	Tcl_Eval(interp, "HideGlyphKeyDialog");
	Tcl_Eval(interp, "HideDimStackKeyDialog");
	Tcl_Eval(interp, "HideChangeNumberOfBinsDialog");
	Tcl_Eval(interp, "HideTimeSeriesAnimationDialog");
	return TCL_OK;
}


//time series animation
static int appGetTimeDimensionMinMax(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int time_dim = g_globals.flat_info->time_dim;
	if (time_dim >= g_globals.dataset->all_dims) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	char str[100];
	sprintf(str, "%.2lf %.2lf", g_globals.dataset->all_dim_min[time_dim],
		g_globals.dataset->all_dim_max[time_dim]);

	Tcl_SetResult(interp, str, TCL_STATIC);
	return TCL_OK;
}


static int appSetCurrentTime(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	g_globals.flat_info->current_time = atof(argv[1]);
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh(true);
	return TCL_OK;
}

static int appSetTimeWindowWidth(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	g_globals.flat_info->time_window_width = atof(argv[1]);
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh(true);
	return TCL_OK;
}

static int appSetTimeStyle(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	g_globals.flat_info->time_method = atoi(argv[1]);
	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh(true);
	return TCL_OK;
}


static int appSetTimeDimension(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		return TCL_OK;
	}

	const char* name = argv[1];
	bool success = false;
	int dimnumber, i;
	for (i = 0; i < g_globals.dataset->all_dims; i++) {
		if (strcmp(name, g_globals.dataset->all_names[i]) == 0) {
			success = true;
			dimnumber = i;
			break;
		}
	}

	if (success) {
		g_globals.flat_info->time_dim = dimnumber;
	}
	return TCL_OK;
}

static int appSetTimeSeriesAnimation(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	if (atoi(argv[1]))
		g_globals.flat_info->time_series_animation = true;
	else
		g_globals.flat_info->time_series_animation = false;

	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);
	canvas->Refresh(true);

	return TCL_OK;
}

static int appTimeSeriesAnimation(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	const char* name = argv[1];
	bool success = false;
	int dimnumber, i;
	for (i = 0; i < g_globals.dataset->all_dims; i++) {
		if (strcmp(name, g_globals.dataset->all_names[i]) == 0) {
			success = true;
			dimnumber = i;
			break;
		}
	}

	if (success) {
		g_globals.flat_info->time_dim = dimnumber;
	}

	grCanvas* canvas = grFindCanvas(interp, "mainCanvas");
	assert(canvas);

	int times = 100;
	bool old = g_globals.flat_info->time_series_animation;
	g_globals.flat_info->time_series_animation = true;
	for (i = 0; i <= times; i++) {
		g_globals.flat_info->current_time = (g_globals.dataset->all_dim_max[g_globals.flat_info->time_dim] -
			g_globals.dataset->all_dim_min[g_globals.flat_info->time_dim]) * i /
			times +
			g_globals.dataset->all_dim_min[g_globals.flat_info->time_dim];
		char str[100];
		sprintf(str, "::.timeSeries::SetCurrentTimeScale %.2lf",
			g_globals.flat_info->current_time);

		Tcl_Eval(interp, str);
		canvas->Refresh(true);
#ifdef WIN32
		Sleep(100);
#else
		sleep(100 / 1000);
#endif
	}

	g_globals.flat_info->time_series_animation = old;
	return TCL_OK;
} 

//new change
static int appGetDefaultFileName(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	Tcl_SetResult(interp, g_globals.default_file_name, TCL_STATIC);

		char str_tst[400];
		strcpy(str_tst, g_globals.default_file_name);

	return TCL_OK;
}

static Tcl_Interp* iiinterp;
void progress(int percent)
{
	std::ostringstream os;
	os << "$w config -percent " << percent;
	Tcl_Eval(iiinterp, (char*)os.str().c_str());
	Tcl_Eval(iiinterp, "update");
}

static int appLoadOkcFile(ClientData clientData, Tcl_Interp* interp, int argc,
						  char* argv[])
{
	iiinterp = interp;

	const char* what = argv[1];
	appCloseOkcFile(clientData, interp, argc, argv);
#ifdef XMDV_USE_BACKEND
	//If data base is active then intialize the cache and make the cache too.
	if(g_globals.hier_info->database)
	{
		//If we are connected to the data base then		
		g_globals.hier_info->databaseInfo.activeFlag = false;		
		//Use the same user name , passwd and dsn as last time
		std::string userName = g_globals.hier_info->databaseInfo.dbConfigStore->userName;
		std::string passwd = g_globals.hier_info->databaseInfo.dbConfigStore->passwd;
		std::string dsnsource = g_globals.hier_info->databaseInfo.dbConfigStore->dsnsource;
		//Instantiate a new database info		
		g_globals.hier_info->databaseInfo.reset();

		//Create the new cache,
		std::string dbFileName = extractDbFileName(argv[1]);
		try{
		
		initCache(dbFileName,userName,passwd,dsnsource);
		}catch(cache::FileNotFoundException fe)
		{
			std::cerr<<fe;
			std::ostringstream stream;
			stream<<fe<<"\"";

			Tcl_VarEval(interp, "ShowCaption \"",
				stream.str().c_str(), 0);

		}catch(otl_exception& p){ // intercept OTL exceptions
			std::ostringstream stream;
			stream<<"Connect Exception"<<"\"";
			std::cerr<<p.code<<std::endl; // print out error code
			std::cerr<<p.sqlstate<<std::endl; // print out error SQLSTATE
			std::cerr<<p.msg<<std::endl; // print out error message
			std::cerr<<p.stm_text<<std::endl; // print out SQL that caused the error
			std::cerr<<p.var_info<<std::endl; // print out thevariable that caused the error
			Tcl_VarEval(interp, "ShowCaption \"",
				stream.str().c_str(), 0);
		}			
	}
#endif
	okcdata *dataset = new okcdata;

	if (dataset->Read(what, progress) == false) {
		Tcl_Eval(interp, "tk_dialog .dialog1 \"Could not load file\" {Could not load the okc file}  info 0 OK");
		delete dataset;
		dataset = NULL;
		return TCL_OK;
	} // if (dataset->Read(what, progress) == false)

	g_globals.dataset = dataset;

	g_globals.screen_distortion->Reset();
//	g_globals.hier_info->Reset();
	g_globals.flat_info->Reset();
	g_globals.dim_reduction_info->Reset();

	grCanvas* interRing_canvas = grFindCanvas(interp, "interRingCanvas");
	if (interRing_canvas != NULL) {
		((CInterRingDisplay *) (interRing_canvas->display))->Reset();
	}

	InitBrushSet();
	Tcl_Eval(iiinterp, "$w config -percent 80");
	Tcl_Eval(iiinterp, "update");
	BrushOperListInit();

	//BrushOperMarkDataset();
	for (int br = 0; br < MAXBRUSH; ++br)
		dataset->brushMgr->ResetBrushCounters(br);

	Tcl_Eval(iiinterp, "$w config -percent 85");
	Tcl_Eval(iiinterp, "update");

	Tcl_Eval(interp, "::.xmdvTool::ResetXmdvFlatInfo");

	Tcl_Eval(interp, "::.brushToolBox::ResetBrushes");

	Tcl_Eval(iiinterp, "$w config -percent 87");
	Tcl_Eval(iiinterp, "update");

	Tcl_Eval(interp, "::.structureBasedBrush::ResetStructureBasedBrushes");

	Tcl_Eval(interp,
		"::.dissimilarityDisplay::SetupDissimilarityDisplayDialog");

	Tcl_Eval(iiinterp, "$w config -percent 90");
	Tcl_Eval(iiinterp, "update");

	Tcl_Eval(interp, "::.glyphPlace::SetupGlyphPlacementDialog");

	Tcl_Eval(iiinterp, "$w config -percent 95");
	Tcl_Eval(iiinterp, "update");

	Tcl_Eval(interp, "::.dimensionReduction::Setup");

	//Zaixian Start
	Tcl_Eval(interp, "::.flatPixelSettings::SetupFlatPixelSettingsDialog");
	//Tcl_Eval(interp, "InitAuxiMisc");
#ifdef USE_META
	//Tcl_Eval(interp, "SetupMetaDialog");
#endif //USE_META
	//Zaixian End

	appRefreshAllCanvas(interp);


	Tcl_Eval(iiinterp, "$w config -percent 98");
	Tcl_Eval(iiinterp, "update");

	return TCL_OK;
}


static int appOnlineClusterOkcFile(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	const char* what = argv[1];

	Tcl_Eval(interp, "RaiseWaitDialog");
	OnlineClusterOkcFileToCgFile(what, 100, true);
	Tcl_Eval(interp, "CloseWaitDialog");

	/*    if (strcmp(what, g_globals.dataset->datafile) )
		{
			g_globals.screen_distortion->Reset();
			g_globals.hier_info->Reset();
			g_globals.dim_reduction_info->Reset();
		}
	*/    
	return TCL_OK;
}


static int appSaveBrushedOkcFile(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	const char* what = argv[1];

	g_globals.dataset->WriteBrushed(what);

	//    appRefreshAllCanvas(interp);
	return TCL_OK;
}

static const char* interface_item_names[] = {
	"background", "text", "data", "highlight1", "highlight2", "highlight3",
	"highlight4", "overlap", "paint", "grid1", "grid2", "grid3", "grid4",
	"stat1", "stat2", "brush1", "brush2", "brush3", "brush4", "sbb"
};

static int appQueryInterfaceColor(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	const char* what = argv[1];
	unsigned int col;

	for (int i = 0; i < NUM_INTERFACE_ITEM; i++) {
		if (strcmp(what, interface_item_names[i]) == 0) {
			col = interface_color[i];

			char str[100];
			sprintf(str, "#%06x", col);

			Tcl_SetResult(interp, str, TCL_STATIC);
			return TCL_OK;
		}
	}

	//    cerr << "Wrong interface item query: " << what << "\n";
	exit(-1);
	return TCL_OK;
}

static int appSetInterfaceColor(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	const char* what = argv[1];
	const char* cstr = argv[2];

	unsigned int col;
	sscanf(cstr + 1, "%x", &col);

	for (int i = 0; i < NUM_INTERFACE_ITEM; i++) {
		if (strcmp(what, interface_item_names[i]) == 0) {
			interface_color[i] = col;

			if (g_globals.dataset)
				BrushOperMarkDataset(); // Need to recolor the points

			return TCL_OK;
		}
	}

	//    cerr << "Wrong interface item query: " << what << "\n";
	exit(-1);
	return TCL_OK;
}

//not used in new release
static int appMainInit(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	//    cout << "--- appMainInit\n";
	//    int result = Tcl_Eval(interp,"InitMainMisc");
	//    cout << "--- End appMainInit\n";
	//    assert(result == TCL_OK);

	//    appRegisterCanvas(interp,"structBrushCanvas","cfNav");
	//    appRegisterCanvas(interp,"interRingCanvas","interRing");
	//    appRegisterCanvas(interp,"histoCanvas","cfHist");
	//    appRegisterCanvas(interp,"minimapCanvas","minimap");
	//    appRegisterCanvas(interp,"treemapCanvas","treemap");
	//    appRegisterCanvas(interp,"glyphToolboxCanvas","glyphtoolbox");
	//    appRegisterCanvas(interp,"stackToolboxCanvas","stacktoolbox");

	return TCL_OK;
}

//shiping
static int appGetNumberOfBins(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	if (which < 0 || which >= g_globals.dataset->all_dims) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	char str[200];
	sprintf(str, "%d", g_globals.dataset->cardinality[which]);

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}
//shiping


//shiping
static int appSetNumberOfBins(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	int num = atoi(argv[2]);

	g_globals.dataset->setNumberOfBins(which, num);

	/*not needed, jing
	if (g_globals.btree) hierReorderDimension();
	appCanvasBrushHasChanged(interp);
	Tcl_Eval(interp,"SetupDataSummary");
	Tcl_Eval(interp,"SetupGlyphKeyDialog");
	Tcl_Eval(interp,"SetupDimStackKeyDialog");
	Tcl_Eval(interp,"SetupBrushStats");
	Tcl_Eval(interp,"SetupClusterBrush");
	Tcl_Eval(interp,"SetupDependentDimensionsMenu");
	*/
	//g_globals.screen_distortion->DimstackReset();
	//appRefreshAllCanvas(interp);
	
	return TCL_OK;
}

//Zaixian
static int appApplyBinsChanged(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	//Copy the number of bins from temporary array to actual array
	for (int i=0; i<g_globals.dataset->dims;i++)
		g_globals.dataset->cardinality[i] = g_globals.dataset->tempCardinality[i];
	g_globals.dataset->ReverseMapData(g_globals.dataset->cardinality, g_globals.dataset->all_cardinality);

	g_globals.screen_distortion->DimstackReset();
	appRefreshAllCanvas(interp);
	
	return TCL_OK;
}

static int appGetWeightOfDim(ClientData clientData, Tcl_Interp* interp,
							 int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	if (which < 0 || which >= g_globals.dataset->all_dims) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	Tcl_ListObjAppendElement(interp, Tcl_GetObjResult(interp), 
		Tcl_NewIntObj(g_globals.dataset->weight[which]));

	return TCL_OK;
}

static int appSetWeightOfDim(ClientData clientData, Tcl_Interp* interp,
							 int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	int which = atoi(argv[1]);
	int num = atoi(argv[2]);

	g_globals.dataset->setWeightOfDim(which, num);
	//appRefreshAllCanvas(interp);
	return TCL_OK;
}

static int appApplyWeightChanges(ClientData clientData, Tcl_Interp* interp,
								 int argc, char* argv[])
{
	if (!g_globals.dataset) {
		Tcl_SetResult(interp, "", TCL_STATIC);
		return TCL_OK;
	}

	//Added by Zaixian begin
	for (int i=0; i<g_globals.dataset->dims;i++)
		g_globals.dataset->weight[i] = g_globals.dataset->tempWeight[i];
	g_globals.dataset->ReverseMapData(g_globals.dataset->weight, g_globals.dataset->all_weight);
	//Zaixian end
	if (g_globals.flatqipixel) {
		g_globals.flatqipixel->ComputeQueryDist(g_globals.flatqipixel->GetSortedDim(),
			g_globals.flatqipixel->GetSortDimOrder());
	}
	appRefreshAllCanvas(interp);
	return TCL_OK;
}

#include <xmdv/colorassign.h>

static int appSetColorMapping(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	const char* what = argv[1];
	strcpy(g_globals.flat_info->colorassigned.colorprefer, what);

	appRefreshAllCanvas(interp);
	return TCL_OK;
}


#include <xmdv/gu_link.h>
Link_List< RGBt> magenta, heatedobject;

static int appLoadColorScaleDataFile(ClientData clientData,
	Tcl_Interp* interp, int argc, char* argv[])
{
	std::ifstream ifs;
	ifs.open("color_data/magenta.dat");
	if (ifs == NULL) {
		Tcl_SetResult(interp, "cannot open magenta color scale data file",
			TCL_STATIC);
		return TCL_OK;
	}

	int i = 0;
	for (i = 0; i < 256; i++) {
		RGBt rgbt;
		ifs >> rgbt;
		magenta.right_add(rgbt);
	}
	ifs.close();


	ifs.open("color_data/heatedobject.dat");
	if (ifs == NULL) {
		Tcl_SetResult(interp,
			"cannot open heated object color scale data file", TCL_STATIC);
		return TCL_OK;
	}

	for (i = 0; i < 256; i++) {
		RGBt rgbt;
		ifs >> rgbt;
		heatedobject.right_add(rgbt);
	}
	ifs.close();


	//    appRefreshAllCanvas(interp);

	return TCL_OK;
}

static int appSetColorScale(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	const char* what = argv[1];
	strcpy(g_globals.flat_info->colorscale, what);


	appRefreshAllCanvas(interp);
	return TCL_OK;
}

//shiping

//Anil
static int appEditColorMap(ClientData clientData, Tcl_Interp* interp, int argc,
						   char* argv[])
{
	const char* what = argv[1];
	g_globals.cmapeditor->EditColorMap(what);
	return TCL_OK;
}

// [8/13/2004]
static int appCanvasFitAll(ClientData clientData, Tcl_Interp* interp, int argc,
						   char* argv[])
{
	grCanvas* main_canvas = grFindCanvas(interp, "mainCanvas");
	main_canvas->FitAll();

	return TCL_OK;
}

static int appGetTitle(ClientData clientData, Tcl_Interp* interp, int argc,
	char* argv[])
{
	Tcl_Obj *obj = Tcl_NewStringObj("XmdvTool ", -1);
	Tcl_AppendStringsToObj(obj, XMDV_VERSION, NULL);
	Tcl_SetObjResult(interp, obj);
	return TCL_OK;
}

void appShowURIDialog(Tcl_Interp* interp, const char* fileName,
	const char* fileContents)
{
	Tcl_Eval(interp, "ShowURIDialog");

	Tcl_Eval(interp, "[W txtLocation] config -state normal");
	Tcl_Eval(interp, "[W txtURIContents] config -state normal");
	Tcl_Eval(interp, "[W txtLocation] delete 0 end");
	Tcl_Eval(interp, "[W txtURIContents] delete 0.0 end");
	Tcl_VarEval(interp, "[W txtLocation] insert end ", fileName, 0);
	Tcl_VarEval(interp, "[W txtURIContents] insert end {", fileContents, "}",
		0);
	Tcl_Eval(interp, "[W txtLocation] config -state disabled");
	Tcl_Eval(interp, "[W txtURIContents] config -state disabled");
}

static int appSetupMetaDialog(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
#ifdef USE_META

	if (!g_globals.dataset->hasMeta) {
		Tcl_Eval(interp, "set ans [::.metaDisplay::askToCreateNewMeta]");
		int ans; Tcl_GetIntFromObj(interp, Tcl_GetObjResult(interp), &ans);
		switch (ans) {
		case 0:
			// Yes
			g_globals.dataset->CreateNewMeta();
			break;
		case 1:
			// No

			break;
		}
	}

	if (g_globals.dataset->hasMeta) {
		Tcl_Eval(interp, "Window show [W MetaDialog]");
		Tcl_Eval(interp, "raise [W MetaDialog]");

		std::ostringstream oss;
		IMeta* meta = MetaFactory::instance()->getMeta();

		// fill up text-box
		meta->marshal(oss, 0);
		Tcl_Eval(interp, "[W txtMetaXML] config -state normal");
		Tcl_Eval(interp, "[W txtMetaXML] delete 0.0 end");
		Tcl_VarEval(interp, "[W txtMetaXML] insert end {", oss.str().c_str(),
			"}", 0);
		Tcl_Eval(interp, "[W txtMetaXML] config -state disabled");

		// fill up dimension list
		Tcl_Eval(interp, "[W lstMetaDim] delete 0 end");
		int dimCount = meta->getDimensionCount();
		for (int i = 0; i < dimCount; ++i) {
			IDimension* dimension = meta->getDimension(i);
			Tcl_VarEval(interp, "[W lstMetaDim] insert end ",
				dimension->getName(), 0);
		}

		Tcl_Eval(interp, "SetupXMLMetaEditor \"\"");
	}

#endif // USE_META

	return TCL_OK;
}

static int appGetMetaDimType(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	char str[200];

#ifdef USE_META

	if (g_globals.dataset->hasMeta) {
		IMeta* meta = MetaFactory::instance()->getMeta();

		const char* dimname = argv[1];
		IDimension* dimension = meta->getDimension(dimname);

		sprintf(str, "%s", dimension->getType().getName());
	} else
		#endif // USE_META
	{
		sprintf(str, "");
	}

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}

static int appGetMetaTypes(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
	char str[200];

#ifdef USE_META

	if (g_globals.dataset->hasMeta) {
		sprintf(str, "real integer word string uri");
	} else
		#endif // USE_META
	{
		sprintf(str, "");
	}

	Tcl_SetResult(interp, str, TCL_STATIC);

	return TCL_OK;
}

static int appGetMetaMappings(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
#ifdef USE_META

	if (g_globals.dataset->hasMeta) {
		IMeta* meta = MetaFactory::instance()->getMeta();

		const char* dimname = argv[1];
		IDimension* dimension = meta->getDimension(dimname);

		IDimension::MappingIterator* iter = dimension->getMappingIterator();
		while (iter->hasNext()) {
			float fValue; IValue* vValue;
			iter->next(&fValue, &vValue);

			Tcl_Eval(interp,
				"entry $f.f0$row -background white -font {{MS Sans Serif} 10}");
			Tcl_Eval(interp, "grid $f.f0$row -column 0 -row $row -sticky nsew");
			char str[50]; sprintf(str, "%.2f", fValue);
			Tcl_VarEval(interp, "$f.f0$row insert end ", str, 0);

			Tcl_Eval(interp,
				"entry $f.f1$row -background white -font {{MS Sans Serif} 10}");
			Tcl_Eval(interp, "grid $f.f1$row -column 1 -row $row -sticky nsew");
			Tcl_VarEval(interp, "$f.f1$row insert end {",
				vValue->getStringRepresentation(), "}", 0);

			Tcl_Eval(interp, "incr row");
		}
	}
#endif // USE_META
	return TCL_OK;
}

static int appSaveMetaInfo(ClientData clientData, Tcl_Interp* interp,
	int argc, char* argv[])
{
#ifdef USE_META
	if (g_globals.dataset->hasMeta) {
		// Get the meta filename from the okc file name
		//
		std::string okcFilename(g_globals.dataset->datafile);
		char* temp = strrchr(g_globals.dataset->datafile, '.');
		std::string metaFilename = okcFilename.substr(0,
			temp - g_globals.dataset->datafile + 1) + "meta";
		std::ofstream os(metaFilename.c_str());
		if (os) {
			IMeta* meta = MetaFactory::instance()->getMeta();
			meta->marshal(os, 0);
		}
	}
#endif // USE_META

	return TCL_OK;
}

// [2/16/2004]
static int appSetCMAPCurrCmpnt(ClientData clientData, Tcl_Interp* interp,
							   int argc, char* argv[])
{
	g_globals.cmapeditor->SetCurrCmpnt(atoi(argv[1]));
	return TCL_OK;
}

static int appSetCMAPCurrPtMode(ClientData clientData, Tcl_Interp* interp,
							   int argc, char* argv[])
{
	if (strcmp(argv[1], "constant") == 0)
		g_globals.cmapeditor->SetCurrPtMode(ColorRamp::CONSTANT);
	else if (strcmp(argv[1], "linear") == 0)
		g_globals.cmapeditor->SetCurrPtMode(ColorRamp::LINEAR);
	else if (strcmp(argv[1], "polynomial") == 0)
		g_globals.cmapeditor->SetCurrPtMode(ColorRamp::POLYNOMIAL);

	return TCL_OK;
}

static int appCMAPDelCurrPt(ClientData clientData, Tcl_Interp* interp,
							   int argc, char* argv[])
{
	g_globals.cmapeditor->RemoveCurrPt();
	return TCL_OK;
}

static int appLoadDatFile(ClientData clientData, Tcl_Interp* interp,
						  int argc, char* argv[])
{
	bool ret = false;
	std::ifstream ifs(argv[1]);
	if (ifs) {
		ret = g_globals.cmapeditor->Load(ifs);
	}

	if (!ifs || !ret)
		Tcl_VarEval(interp, "tk_dialog .dialog1 \"Could not load colormap\" \
			{Could not load ", argv[1], "}  info 0 OK", 0);

	return TCL_OK;
}

static int appCMAPModeSelect(ClientData clientData, Tcl_Interp* interp,
						     int argc, char* argv[])
{
	CColorMapEditor::CMAPMode mode = g_globals.cmapeditor->GetCMAPMode();
	if (strcmp(argv[1], "rgba") == 0)
		mode = CColorMapEditor::MODE_RGBA;
	else if (strcmp(argv[1], "hsva") == 0)
		mode = CColorMapEditor::MODE_HSVA;
	else if (strcmp(argv[1], "grey") == 0)
		mode = CColorMapEditor::MODE_GREY;
	g_globals.cmapeditor->SetCMAPMode(mode);
	return TCL_OK;
}
//Anil

//Zaixian to update Anil's code
static int appSetFlatPixel(ClientData clientData, Tcl_Interp* interp,
						  int argc, char* argv[])
{
	char str[255];
	sprintf(str, "::.flatPixelSettings::flatPixelSettingsApply ::%s %s", argv[1], argv[2]);
	Tcl_Eval(interp, str);
	return TCL_OK;
}

static int appUpdateFlatPixel(ClientData clientData, Tcl_Interp* interp,
						  int argc, char* argv[])
{
	CPixelOriented *pixel;
	if (g_globals.flatqipixel)
		pixel = g_globals.flatqipixel;
	else if (g_globals.hierpixel)
		pixel = g_globals.hierpixel;
	else
		return (TCL_OK);

	if ( strcmp(argv[1], "::.flatPixelSettings.fraTop.entSortedBy") == 0 ) {
		int selDim;
		if ( strcmp(argv[2], "Combined_Distance")==0 ) {
			selDim = 0;
		} else {
			selDim = 0;
			while (selDim<g_globals.dataset->all_dims) {
				if ( strcmp(argv[2], g_globals.dataset->all_names[selDim])==0 ) {
					selDim++;
					break;
				} else {
					selDim++;
				}

			}
		}

		pixel->SetSortedDim( selDim );
	}
	if ( strcmp(argv[1], "::.flatPixelSettings.fraTop.comboSortOrder") == 0 ) {
		pixel->SetSortDimOrder( atoi(argv[2]) == 0 );
	}
	if ( strcmp(argv[1], "::.flatPixelSettings.fraTop.entSelectedDim") == 0 ) {
		int selDim;
		if ( strcmp(argv[2], "Combined_Distance")==0 ) {
			selDim = 0;
		} else {
			selDim = 0;
			while (selDim<g_globals.dataset->all_dims) {
				if ( strcmp(argv[2], g_globals.dataset->all_names[selDim])==0 ) {
					selDim++;
					break;
				} else {
					selDim++;
				}

			}
		}

		pixel->SelectDim(selDim);
		pixel->SetDimDistortion(
			selDim, pixel->GetDimDistortion(selDim));

	}
	if ( strcmp(argv[1], "::.flatPixelSettings.fraTop.scaDistortion") == 0 ) {
		pixel->SetDimDistortion(
			pixel->GetSelectedDim(), atoi(argv[2])/100.0f);
	}

	if ( strcmp(argv[1], "::.flatPixelSettings.fraBottom.cheShowColormap") == 0 ) {
		if ( atoi(argv[2]) == 1 )
			pixel->ShowColormap(true);
		else
			pixel->ShowColormap(false);
	}

	if ( strcmp(argv[1], "::.flatPixelSettings.fraBottom.cheShowDerived") == 0 ) {
		if ( atoi(argv[2]) == 1 )
			pixel->ShowDerived(true);
		else
			pixel->ShowDerived(false);
	}

	if ( strcmp(argv[1], "::.flatPixelSettings.fraBottom.cheMDSPlacement") == 0 ) {
		if ( atoi(argv[2]) == 1 )
			pixel->SetPlacementType(CFlatPixel::PPT_MDS);
		else
			pixel->SetPlacementType(CFlatPixel::PPT_NORMAL);
	}

	if ( strcmp(argv[1], "::.flatPixelSettings.fraBottom.cheSampling") == 0 ) {
		if ( atoi(argv[2]) == 1 ) 
			pixel->SetSamplingFactor( atoi(argv[3])/100.0f );
		else
			pixel->SetSamplingFactor(1.0f);
	}

	if ( strcmp(argv[1], "::.flatPixelSettings.fraBottom.scaSampling") == 0 ) {
		if ( atoi(argv[2]) == 1 ) {
			pixel->SetSamplingFactor( atoi(argv[3])/100.0f );
		} else
			pixel->SetSamplingFactor(1.0f);
	}

	return TCL_OK;
}
//Zaixian to update Anil's code

//Zaixian to add code for treemap
/*
static int appUpdateDependentDim(ClientData clientData, Tcl_Interp* interp,
						  int argc, char* argv[])
{
	char str[255];
	sprintf(str, "::.auxiDisplay::ChangeDependentDimension %s", argv[2]);
	Tcl_Eval(interp, str);
	return TCL_OK;
}
*/
//Zaixian end

void exitProc(ClientData clientData)
{
	Tcl_Interp *interp = (Tcl_Interp*) clientData;

	Tcl_Eval(interp, "DestroyAllCanvas");

	exit(0);
}

static int InitApplication(Tcl_Interp* interp)
{
	assert(interp);
	// Initialize TCL, TK, and TOGL.
	//
	if (Tcl_Init(interp) == TCL_ERROR)
		return TCL_ERROR;
	if (Tk_Init(interp) == TCL_ERROR)
		return TCL_ERROR;
	if (Togl_Init(interp) == TCL_ERROR)
		return TCL_ERROR;

	// Application UI Tcl File
	Tcl_SetVar(interp, "tcl_rcFileName", (char *) interface_file,
		TCL_GLOBAL_ONLY);

	// Sets up a function where we can startup our application
	//
	Togl_CreateFunc(grCanvas::grInitCanvas);
	Togl_DisplayFunc(grCanvas::grDisplayEvent);
	Togl_ReshapeFunc(grCanvas::grReshapeEvent);
	Togl_DestroyFunc(grCanvas::grDestroyCanvas);

	// Setup C hooks to Tk interface
	//
#define ADD_COMMAND(X) Tcl_CreateCommand(interp, "" #X "", X, 0, 0);

	ADD_COMMAND(appMainInit);
	ADD_COMMAND(appMainCanvasRefresh);
	ADD_COMMAND(appRefreshAllCanvas);
	ADD_COMMAND(appModeSelect);
	ADD_COMMAND(appLoadOkcFile);
	ADD_COMMAND(appOnlineClusterOkcFile);
	ADD_COMMAND(appSaveBrushedOkcFile);
	ADD_COMMAND(appCloseOkcFile);
	ADD_COMMAND(appQueryInterfaceColor);
	ADD_COMMAND(appSetInterfaceColor);
	ADD_COMMAND(appSetCanvasZoom);
	ADD_COMMAND(appSetCanvasZoomOneDirection);
	ADD_COMMAND(appGetCanvasViewParameters);
	ADD_COMMAND(appSetViewScrollTo);
	ADD_COMMAND(appGetDatasetSummary);
	//Zaixian
	ADD_COMMAND(appGetShortName);
	ADD_COMMAND(appGetFullPath);
	//Zaixian
	ADD_COMMAND(appQueryGlyphKey);
	ADD_COMMAND(appSetDimensionReduction);
	ADD_COMMAND(appQueryDimStackKey);
	ADD_COMMAND(appGetFieldInfo);
	ADD_COMMAND(appGetDimensionInfo);
	ADD_COMMAND(appGetDimensionNames);
	ADD_COMMAND(appGetPrincipalNames);
	ADD_COMMAND(appGetClusterBrush);
	ADD_COMMAND(appGetDimReductionToolbox);
	ADD_COMMAND(appSetFieldOnOff);
	//jing - new changes
	ADD_COMMAND(appGetDefaultFileName);
	ADD_COMMAND(appReorderDimension);
	ADD_COMMAND(appSimilarityBasedReorder);  // added by debbie
	ADD_COMMAND(appClutterBasedReorder); // added by debbie 9/2003
	ADD_COMMAND(appGetThresholdRange);	// added by debbie
	ADD_COMMAND(appGetDefaultThreshold); // added by debbie
	ADD_COMMAND(appGetActiveDimension); // added by debbie
	ADD_COMMAND(appGlyphPlacementSort);
	ADD_COMMAND(appGlyphPlacementOriginal);
	ADD_COMMAND(appSetInterRingDisplayActionMode);
	ADD_COMMAND(appSetDimReductionStatus);
	ADD_COMMAND(appGetFlatInfo);
	ADD_COMMAND(appSetDimReductionAxisColor);
	ADD_COMMAND(appInterRingDisplayReset);
	ADD_COMMAND(appGetInterRingDisplayInfo);
	ADD_COMMAND(appSetInterRingDisplayParameter);
	ADD_COMMAND(appTimeSeriesAnimation);
	ADD_COMMAND(appGetTimeDimensionMinMax);
	ADD_COMMAND(appSetTimeDimension);
	ADD_COMMAND(appSetCurrentTime);
	ADD_COMMAND(appSetTimeSeriesAnimation);
	ADD_COMMAND(appSetTimeWindowWidth);
	ADD_COMMAND(appSetTimeStyle);
	ADD_COMMAND(appInterRingDisplayReorder);


	//NEW - zfc
	ADD_COMMAND(appGlyphShapeOriginal);
	ADD_COMMAND(appGlyphShapeNew);
	//NEW - zfc
	ADD_COMMAND(appGlyphPlacementDataDriven);
	ADD_COMMAND(appGlyphPlacementDerived);
	ADD_COMMAND(appDrawBrushStatsCanvas);
	ADD_COMMAND(appSetBandsOnOff);
	ADD_COMMAND(appSetDimReductionDisagreePresent);
	ADD_COMMAND(appMagnify);
	ADD_COMMAND(appDeMagnify);
	ADD_COMMAND(appSetClusterRadius);
	ADD_COMMAND(appSetBrushedRadius);
	ADD_COMMAND(appSetExtentScalingFactor);
	ADD_COMMAND(appSetDimReductionExtentScalingFactor);
	ADD_COMMAND(appSetTreeBrush);
	ADD_COMMAND(appSetDynamicMaskingScale);
	ADD_COMMAND(appGlobalBrushResize);
	ADD_COMMAND(appSetBrushEnableState);
	ADD_COMMAND(appSetBrushDisplayState);
	ADD_COMMAND(appSetBrushBoundaryType);
	ADD_COMMAND(appSetActiveBrush);
	ADD_COMMAND(appGetDimensionName);
	ADD_COMMAND(appDependentDimensionHasChanged);
	ADD_COMMAND(appSaveMainCanvasImage);
	ADD_COMMAND(appRegisterCanvas);
	ADD_COMMAND(appUnRegisterCanvas);
	ADD_COMMAND(appSetDoubleBuffer);
	ADD_COMMAND(appNewBrushOps);
	ADD_COMMAND(appDeleteBrushOps);
	ADD_COMMAND(appFormBrushExpr);
	ADD_COMMAND(appGetBrushOpString);
	ADD_COMMAND(appRaiseOperPriority);
	ADD_COMMAND(appLowerOperPriority);
	ADD_COMMAND(appGetBrushOps);
	ADD_COMMAND(appGetNumBrushes);
	ADD_COMMAND(appGetBrushExpr);
	//  ADD_COMMAND(appUpdataDisplays);
	ADD_COMMAND(appSetupDataValuesDialog);
	ADD_COMMAND(appSetNormalStatus);
	ADD_COMMAND(appSetDistortionStatus);
	ADD_COMMAND(appResetDistortion);
	//    ADD_COMMAND(appSizeStructureSelectInterRing);
	//    ADD_COMMAND(appRadiusStructureSelectInterRing);
	ADD_COMMAND(appGetCanvasZoomOneDirection);
	ADD_COMMAND(appGetGlyphPlacementInfo);
	ADD_COMMAND(appInterRingDisplaySelection);

	/* Jing SID */
	ADD_COMMAND(appConnectDatabase);
	ADD_COMMAND(appDisconnectDatabase);	
	ADD_COMMAND(appStartBackendDemo);
	/* SID */
	ADD_COMMAND(appSetPrefetcher);
	ADD_COMMAND(appSetBrushSemantic);
	ADD_COMMAND(appSetPrefetchStrategy);	
	ADD_COMMAND(appTest);
	ADD_COMMAND(appStartPrefetcher);
	ADD_COMMAND(appStopPrefetcher);
	ADD_COMMAND(appDisplayTime);


	//shiping
	ADD_COMMAND(appGetNumberOfBins);
	ADD_COMMAND(appSetNumberOfBins);
	ADD_COMMAND(appSetColorMapping);
	ADD_COMMAND(appLoadColorScaleDataFile);
	ADD_COMMAND(appSetColorScale);
	//shiping

	//Added by Zaixian begin
	ADD_COMMAND(appApplyBinsChanged);
	//Zaixian end

	//Anil
	ADD_COMMAND(appEditColorMap);
	ADD_COMMAND(appCanvasFitAll);
	ADD_COMMAND(appGetTitle);
	ADD_COMMAND(appSetupMetaDialog);
	ADD_COMMAND(appGetMetaDimType);
	ADD_COMMAND(appGetMetaTypes);
	ADD_COMMAND(appGetMetaMappings);
	ADD_COMMAND(appSaveMetaInfo);

	ADD_COMMAND(appSetCMAPCurrCmpnt);
	ADD_COMMAND(appSetCMAPCurrPtMode);
	ADD_COMMAND(appCMAPDelCurrPt);
	ADD_COMMAND(appLoadDatFile);
	ADD_COMMAND(appCMAPModeSelect);

	ADD_COMMAND(appGetWeightOfDim)
	ADD_COMMAND(appSetWeightOfDim)
	ADD_COMMAND(appApplyWeightChanges);
	//Anil

	//Zaixian
	ADD_COMMAND(appSetFlatPixel);
	ADD_COMMAND(appUpdateFlatPixel);
	//ADD_COMMAND(appUpdateDependentDim);
	//Zaixian

	// PAUL: tk_opt
	// Hooks for updating the DataValuesText widget intelligently
	ADD_COMMAND(BrushMgr::BrushedDataValuesUpdate);

	Tcl_CreateExitHandler(exitProc, (ClientData)interp);
	appInitGlobals();

	return TCL_OK;
}

//ofstream LOGFP("LOG");

int main(int argc, char** argv)
{
	static float unbrushedCMapVals[2][5] = {
		{ 0, 65, 255, 255, 255 },
		{ 255, 255, 255, 160, 255 },
	};
	g_globals.pixelUnbrushedCMap = new colormap("Pixel Unbrushed", new ColorRamp(CMAPSIZE, 2, unbrushedCMapVals),
		CMAPSIZE, colormap::MODEL_HSV);

	static float brushedCMapVals[2][5] = {
		{ 0, 255, 255, 0, 255 },
		{ 255, 255, 255, 0, 255 },
	};
	g_globals.pixelBrushedCMap = new colormap("Pixel Brushed", new ColorRamp(CMAPSIZE, 2, brushedCMapVals),
		CMAPSIZE, colormap::MODEL_RGB);

	srand((unsigned int)time(NULL));

	//LOG("XmdvTool Started in main().");

	// Search for the Tk/Tcl interface file.
	// Assumes interface file is named <executable>.tcl
	//
	char* tclenv = getenv("TCL_LIBRARY");
	if (tclenv == 0) {
		putenv("TCL_LIBRARY=./lib/tcl8.1");
	}

	char* tkenv = getenv("TK_LIBRARY");
	if (tkenv == 0) {
		putenv("TK_LIBRARY=./lib/tk8.1");
	}

	char working_dir[1024];
	char* home = getenv("XMDV_HOME");
	if (home == 0) {
		strcpy(working_dir, "..");
	} else {
		strcpy(working_dir, home);
	}
	strcat(working_dir, "/bin");

#ifdef _WIN32
	_chdir(working_dir);
#else
	chdir(working_dir);
#endif // _DEBUG

	//#ifdef _WIN32
	//    setenv("TCL_LIBRARY","./LIB/TCL8.0",1);
	//jing
	//    putenv(tclenv);
	//    strcpy(interface_file, home);
	//	strcat(interface_file, "/bin/scripts/XmdvTool.tcl");
	//#else
	//    putenv(tclenv);
	//    putenv(tkenv);
	//    //realpath(argv[0],interface_file);
	//    //strcat(interface_file,".tcl");
	//#endif
	/*
	static char gooey_dir[200];
	strcpy(gooey_dir, working_dir);
	strcat(gooey_dir, "/gui");
	Gooey::WindowManager::instance().initialize(std::string(gooey_dir) + "/accid___.ttf", NULL, NULL, NULL);
	Gooey::WindowManager::instance().propertyScheme().load(std::string(gooey_dir) + "/gskin.xml");
	*/
	strcpy(interface_file, working_dir);
	strcat(interface_file, "/scripts/XmdvTool.tcl");


	struct stat buf;
	int exists = stat(interface_file, &buf);
	if (exists != 0) {
		std::cerr << "Missing Interface Definition file: \"" << interface_file
				  << "\"." << std::endl;
		std::cerr << "Make sure that current directory is the 'bin' directory"
				  << std::endl;
		exit(-1);
	}

	/* SID */
	if (backend)
		db_connect_to_database("xmdv@kenny.wpi.edu", "xmdv");


	g_globals.screen_distortion = new CScreenDistortion();
	g_globals.flat_info = new CFlatDisplayInformation(); 
	g_globals.hier_info = new CHierDisplayInformation(); 
	g_globals.dim_reduction_info = new CDimReductionDisplayInformation();

	g_globals.histMgmt = new HistMgmt();	//YK
	//new change
	
	if (argc > 1 ) {
		g_globals.default_file_name = argv[1];
	} else {
		g_globals.default_file_name = new char[strlen(working_dir) + 20];
		strcpy(g_globals.default_file_name, working_dir);
		strcat(g_globals.default_file_name, "/../data/cars.okc");
	}

	g_globals.buffersize = 40000; //Set the default buffer size

	Tk_Main(argc, argv, InitApplication);
	assert(0); // We should never get here.

	return 0;
}

/**
 * Does nothing just used as a stub.
 * \param backend 
 */
void SetBackend(bool backend)
{

}
