/* file: globalAverage.c 
 * purpose: define Global Average class
 * revision log:
 */

#include "globalAverage.h"
#include <stdlib.h>
#include <stdio.h>

struct globalAverage_Str
{	int nQueries ;  /* # queries seen so far */
	float sumM ;    /* sum of measure M values for the queries
					     seen so far */
    float average ; /* global average value */
} globalAverage_Str ;


globalAverage globalAverage_Create()
{ 
	globalAverage g ;

	g = (globalAverage) malloc(sizeof(struct globalAverage_Str)) ;
	if (g != NULL)
	{ 	g->nQueries = 0 ;
		g->sumM = 0.0 ;
		g->average = 0.0 ;
	}
	return(g) ;
}


void globalAverage_Destroy(globalAverage g) 
{ 
	free(g) ;
}


float globalAverage_Update(globalAverage g, float m) 
{
	g->nQueries++ ;
	g->sumM = g->sumM + m ;
	g->average = g->sumM / g->nQueries ;
	return(g->average) ;
}

float globalAverage_GetValue(globalAverage g) 
{
	return(g->average) ;
}

void globalAverage_Test()
{
	globalAverage g ;

	printf("Testing globalAverage class -- begin\n") ;

	if ((g = globalAverage_Create()) == NULL)
		printf("No more memory\n") ;
	else
	{
		printf("+ 1.0, average=%f \n", globalAverage_Update(g, 1.0)) ;
		printf("+ 2.0, average=%f \n", globalAverage_Update(g, 2.0)) ;
		printf("+ 3.0, average=%f \n", globalAverage_Update(g, 3.0)) ;
		printf("+ 4.0, average=%f \n", globalAverage_Update(g, 4.0)) ;
		printf("+ 5.0, average=%f \n", globalAverage_Update(g, 5.0)) ;
	}

	globalAverage_Destroy(g) ;
	printf("Testing globalAverage class -- done\n") ;
	return ;
}
